/*
cmfconfig.h
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
*/
#include "config.h"
#include <cstdlib>
#include <cstring>
#include "cmfconfig.h"

#ifdef _DEBUGGERY
extern int DebugLevel;
#endif

#define _DEBUGGERY
int DebugLevel=666;

CMfConfig::CMfConfig()
{  
   xsize=800;
   ysize=600;
   bTcp=false;
   bUdp=true;
   bModal=false;
   smartbarpos=0;
   smartbartype=0;
   bSmartbarshowkeys=true;
   keypad=0;
   keyboard=0;

   AutoDropTimeout=2000;   // 20 seconds
   bLogoutEveryTrans=true;
   bAllowPassiveReturns=true;
   bConfirmCommit=false;
   bDrawerPolicy=false;
   
   bTransMulti=false;
   bTransServerSide=false;
   trans_history_stacksize=0;
   bTransAssigned=false;
   bAuthCash=false;
   bExternCredit=false;
   bMultiPrice=false;
   bMultiTax=false;
   bReturnInSale=false;
   bReturnReason=false;
   authcashlimit=0;
   bTaxInclusive=true;
   numbbretries=3;
   bBlindBalAtlogout=false;
   bZtapeAlogout=false;
   bCashdResetAtlogin=false;
   bCashSale=false;
   
   bCustomerAdd=false;
   bPluMinimum=false;
   bChargeAcc=false;
   bCustomerMode=false;

   plutimeout=50; //mS
   /*
   powerfailpolicy=1;
   powerfailtimeout=120;
   requestretries=0;
   shutdownpolicy=1;
   
   bSessionTimeout=false;*/

   shost="";
   chost="";
   sport=6672;
   cport=6672;
   netdev="";
   
   bUseGlobalPrintSettings=true;
   memset(&print_strings, 0, sizeof(print_strings));
   memset(&bc_prefix, 0, sizeof(GlobalPrefix));
   
   bAlphaplu=false;
   bc_prefix.weight_prefix=22;
   bc_prefix.quantity_prefix=21;
   bc_prefix.price_prefix=20;
   bc_prefix.interface_prefix=24;
   bc_prefix.token_prefix=27;
   bc_prefix.voucher_prefix=28;
   bc_prefix.instore_prefix=29;

   prn_xres=180;
   prn_yres=180;
   charset=0;
   reccharline=0;
   jrncharline=0;
   slipcharline=0;
   recfont=0;
   jrnfont=0;
   slipfont=0;
   nvramsize=0;
   defaultcheque=0;
   bBarcodeCaps=false;
   bPageModeCaps=false;
   bAutoCutter=false;

   dBcscanner=bhpos::BCDEV_TYPE_NONE;
   memset(&sdevBcscanner, 0, sizeof(sdevBcscanner));
   
   dCashd=bhpos::CDDEV_TYPE_NONE;
   bcashdbeeponopen=false;
   memset(&sdevCashd, 0, sizeof(sdevCashd));
   
   dCustdisp=bhpos::CPDEV_TYPE_NONE;
   typeCustdisp=0;
   xsizeCustdisp=0;
   ysizeCustdisp=0;
   reverttimerCustdisp=0;
   memset(&sdevCustdisp, 0, sizeof(sdevCustdisp));
   
   dPrinter=bhpos::PRNDEV_TYPE_NONE;
   memset(&sdevPrinter, 0, sizeof(sdevPrinter));
   
   dMagswipe=bhpos::MSDEV_TYPE_NONE;
   memset(&sdeMagswipe, 0, sizeof(sdeMagswipe));
   
   dScales=bhpos::SCDEV_TYPE_NONE;
   memset(&sdevScales, 0, sizeof(sdevScales));
  
   ps2bcprefix=0x02;   // STX
   ps2bcpostfix=0x03;  // ETX
   
   memset(&taxlist, 0, sizeof(TaxList));
   memset(&pricelist, 0, sizeof(PriceList));
   
   imagedir="";
   
   /*
   pgui=new PostGUI;
	if(pgui){
		memset(pgui, 0, sizeof(pgui));
		pgui->colour_default_foreground.pixel=1;
		pgui->colour_default_background.pixel=1;
		pgui->colour_foreground_selected.pixel=1;
		pgui->colour_background_selected.pixel=1;
		pgui->colour_cell_foreground.pixel=1;
		pgui->colour_payment_background.pixel=1;
		pgui->colour_paymenthdr_foreground.pixel=1;
		pgui->colour_paymentlist_foreground.pixel=1;
		pgui->colour_uplu_foreground.pixel=1;
		pgui->colour_plulookup_foreground.pixel=1;
		pgui->colour_return_foreground.pixel=1;
		pgui->colour_layby_foreground.pixel=1;
		pgui->colour_rental_foreground.pixel=1;
		pgui->colour_ephemeral_foreground.pixel=1;
	}
   
   bNoLogin=false;*/
   bMultipleSalePrices=false;
   bDisappearMouse=true;
   bNoClose=true;
   bNoMinimize=true;
   bStick=false;
   bDecorated=true;
   //userlogin="";
   //password="";
}

CMfConfig::~CMfConfig()
{
}

int CMfConfig::Parse(char *filename)
{
   if(!filename){
      return 1;
   }
   char value[512];
   int  y;
   
   if(Load(filename)){
#ifdef _DEBUGGERY
		printf("No Config file found.\n");
#endif
      return 2;
	}
	else{
		// default stuff
		memset(value, 0, sizeof(value));
		if(!ParseRecord("default", "debuglevel", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting debug level: %s - %d\n", value, atoi(value));
#endif
			y=atoi(value);
         y=666;
#ifdef _DEBUGGERY
			DebugLevel=y;
#endif
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("default", "protocoltcp", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting Protocol TCP: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bTcp=true;
			else
				bTcp=false;
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("default", "devicename", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device name: %s\n", value);
#endif
         if(netdev!=""){
            netdev="";
         }
         netdev=(char *) value;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("default", "host", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting host: %s\n", value);
#endif
         if(shost!=""){
            shost="";
         }
         shost=(char *) value;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("default", "port", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting port: %d\n", atoi(value));
#endif
			sport=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("default", "mchost", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting multicast host: %s\n", value);
#endif
         if(chost!=""){
            chost="";
         }
         chost=(char *) value;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("default", "mcport", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting multicast port: %d\n", atoi(value));
#endif
			cport=atoi(value);
		}
      
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "logouteverytrans", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting logout every trans: %s\n", value);
#endif
			if(*value=='Y' || *value=='y'){
				bLogoutEveryTrans=true;
			}
			else{
				bLogoutEveryTrans=false;
			}
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "multiplesaleprice", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting multiple sale price to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y'){
				bMultipleSalePrices=true;
			}
			else{
				bMultipleSalePrices=false;
			}
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "allowpassivereturns", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting allow passive returns to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bAllowPassiveReturns=true;
			else
				bAllowPassiveReturns=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "confirmcommit", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting confirm commit to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bConfirmCommit=true;
			else
				bConfirmCommit=false;
		}
		
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "powerfailpolicy", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting power fail policy: %d\n", atoi(value));
#endif
			powerfailpolicy=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "powerfailtimeout", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting power fail timeout: %d\n", atoi(value));
#endif
			powerfailtimeout=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "requestretries", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting request retries: %d\n", atoi(value));
#endif
			requestretries=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "shutdownpolicy", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting shutdown policy: %d\n", atoi(value));
#endif
			shutdownpolicy=atoi(value);
		}
		
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "xsize", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting disp startup x: %d\n", atoi(value));
#endif
			xsize=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "ysize", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting disp startup y: %d\n", atoi(value));
#endif
			ysize=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "number_catalogue", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting number format to: %s\n", value);
#endif
			if(value!=0){
            /*
            if(shost!=""){
            shost="";
         }
         shost=(char *) value;*/
				//strcpy(x, value);
				//post->SetOption(BH_POST_OPTION_NUMCAT, x);
			}
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "language_catalogue", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting lang format to: %s\n", value);
#endif
			if(value!=0){
				//strcpy(x, value);
				//post->SetOption(BH_POST_OPTION_LANG, x);
			}
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "modal", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting modal to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bModal=true;
			else
				bModal=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "nomouse", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting no mouse to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bDisappearMouse=true;
			else
				bDisappearMouse=false;
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "noclose", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting no close to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
            bNoClose=true;
			else
				bNoClose=false;
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "nominimize", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting no minimize to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
            bNoMinimize=true;
			else
				bNoMinimize=false;
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "stick", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting stick to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
            bStick=true;
			else
				bStick=false;
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("post", "decorated", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting decorated to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
            bDecorated=true;
			else
				bDecorated=false;
		}
      
      memset(value, 0, sizeof(value));
		if(!ParseRecord("ui", "imagedir", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting imagedir to: %s\n", value);
#endif
			if(value[0]!=0){
            imagedir=(char *) value;
			}
		}
      memset(value, 0, sizeof(value));
      if(!ParseRecord("ui", "smartbar", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting smartbar to: %s\n", value);
#endif
			if(value[0]!=0){
            smartbarpos=atoi(value);
			}
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("ui", "smartbartype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting smartbar type to: %s\n", value);
#endif
			if(value[0]!=0){
            smartbartype=atoi(value);
			}
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("ui", "smartbarshowkeys", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting smartbar show keys to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bSmartbarshowkeys=true;
			else
				bSmartbarshowkeys=false;	
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("ui", "keypad", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting keypad to: %s\n", value);
#endif
			if(value[0]!=0){
            keypad=atoi(value);
			}
      }
      memset(value, 0, sizeof(value));
		if(!ParseRecord("ui", "keyboard", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting keyboard to: %s\n", value);
#endif
			if(value[0]!=0){
            keyboard=atoi(value);
			}
      }    

		memset(value, 0, sizeof(value));
		if(!ParseRecord("ui", "style_file", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting styel file to: %s\n", value);
#endif
			if(value[0]!=0){
				//strcpy(x, value);
				//post->SetOption(BH_POST_OPTION_STYLEFILE, x);
			}
		}	
		
		// user policy
		memset(value, 0, sizeof(value));
		if(!ParseRecord("user", "unknownplupolicy", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting unknown plu policy: %d\n", atoi(value));
#endif
			plupolicy=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("user", "confirmpolicy", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting confirm policy: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bConfirmPolicy=true;
			else
				bConfirmPolicy=false;			
		}
		
		// plus gear
		memset(value, 0, sizeof(value));
		if(!ParseRecord("plus", "authentication", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting authentication: %d\n", atoi(value));
#endif
			authentification=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("plus", "encryption", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting encryption: %d\n", atoi(value));
#endif
			encryption=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("plus", "sessiondefault", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting session default: %d\n", atoi(value));
#endif
			sessiondefault=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("plus", "sessiontimeout", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting session timeout: %d\n", atoi(value));
#endif
			sessiontimeout=atoi(value);
		}
		
		//
		// transaction options
		//
      memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "autodroptimeout", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting autodroptimeout: %d\n", atoi(value));
#endif
			AutoDropTimeout=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "multipleopen", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting multiple transactions open: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bTransMulti=true;
			else
				bTransMulti=false;			
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "multipleassigned", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting multiple assigned: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bTransAssigned=true;
			else
				bTransAssigned=false;			
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "serverside", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting serverside assigned: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bTransServerSide=true;
			else
				bTransServerSide=false;			
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "authcash", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting auth cash: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bAuthCash=true;
			else
				bAuthCash=false;			
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "taxinclusive", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tax inclusive: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bTaxInclusive=true;
			else
				bTaxInclusive=false;			
		}
		
      memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "blindbalatlogout", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting blind balance at logout: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bBlindBalAtlogout=true;
			else
				bBlindBalAtlogout=false;			
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "blindbalretries", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting blind balance retries: %d\n", atoi(value));
#endif
			numbbretries=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "authcashlimit", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting auth cash limit: %d\n", atoi(value));
#endif
			authcashlimit=atoi(value);
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "historysize", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting trans history size to: %d\n", atoi(value));
#endif
         trans_history_stacksize=atoi(value);
      }
      memset(value, 0, sizeof(value));
      if(!ParseRecord("transaction", "ztapeatlogout", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting z-tape at logout: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bZtapeAlogout=true;
			else
				bZtapeAlogout=false;			
		}
      memset(value, 0, sizeof(value));
      if(!ParseRecord("transaction", "allowcashsale", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting allowcashsale: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bCashSale=true;
			else
				bCashSale=false;			
		}
      memset(value, 0, sizeof(value));
      if(!ParseRecord("transaction", "cashdresetatlogin", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting cashdrawer reset at login: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bCashdResetAtlogin=true;
			else
				bCashdResetAtlogin=false;			
		}
      memset(value, 0, sizeof(value));
      if(!ParseRecord("transaction", "customeradd", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting customer add to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bCustomerAdd=true;
			else
				bCustomerAdd=false;			
		}
      memset(value, 0, sizeof(value));
      if(!ParseRecord("transaction", "pluminimum", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting plu minimum to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bPluMinimum=true;
			else
				bPluMinimum=false;			
		}
      memset(value, 0, sizeof(value));
      if(!ParseRecord("transaction", "chargeacc", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting charge acc to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bChargeAcc=true;
			else
				bChargeAcc=false;			
		}
      memset(value, 0, sizeof(value));
      if(!ParseRecord("transaction", "customermode", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting customer mode to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bCustomerMode=true;
			else
				bCustomerMode=false;			
		}
      
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "plutimeout", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting PLU timeout to: %d\n", atoi(value));
#endif
			plutimeout=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "externalcredit", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting extern timeout to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bExternCredit=true;
			else
				bExternCredit=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "multiplesaleprice", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting extern timeout to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bMultipleSalePrices=true;
			else
				bMultipleSalePrices=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "multipleuplutax", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting extern timeout to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bMultiTax=true;
			else
				bMultiTax=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "nosalecashdrawer", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting can open cashdrawer outside trans to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bDrawerPolicy=true;
			else
				bDrawerPolicy=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "returninsale", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting returns in sale to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bReturnInSale=true;
			else
				bReturnInSale=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "returnreason", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting returns reason: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bReturnReason=true;
			else
				bReturnReason=false;
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("transaction", "alphaplu", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting alpha plu to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bAlphaplu=true;
			else
				bAlphaplu=false;
		}
      
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "useglobalprintsettings", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting use global print settings to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bUseGlobalPrintSettings=true;
			else
				bUseGlobalPrintSettings=false;
		}

/////////////////////////////////////////////////////////////////
//
// station devices
//
//

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ bcscanner ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

		memset(value, 0, sizeof(value));
		if(!ParseRecord("bcscanner", "devicetype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting bc scanner device type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					dBcscanner=bhpos::BCDEV_TYPE_NONE;
				}
				else if(strcmp(value, "keyboard")==0){
					dBcscanner=bhpos::BCDEV_TYPE_KEYBOARD;
				}
            else if(strcmp(value, "serial")==0){
					dBcscanner=bhpos::BCDEV_TYPE_SERIAL;
				}
            else if(strcmp(value, "usb")==0){
					dBcscanner=bhpos::BCDEV_TYPE_PORTABLE;
				}
				else if(strcmp(value, "portable")==0){
					dBcscanner=bhpos::BCDEV_TYPE_PORTABLE;
				}
			}
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("bcscanner", "targetdevice", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting bc scanner device to: %s\n", value);
#endif
			if(value!=0){
            devBcscanner=value;
			}
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("bcscanner", "sentinelstart", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting bc scanner start sentinel to: %s\n", value);
#endif
			if(value!=0){
            ssBcscanner=value;
			}
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("bcscanner", "sentinelend", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting bc scanner end sentinel to: %s\n", value);
#endif
			if(value!=0){
            esBcscanner=value;
			}
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("bcscanner", "targetspeed", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting bc scanner serial speed to: %s\n", value);
#endif
			if(value!=0){
            sdevBcscanner.speed=atoi(value);
			}
		}
      memset(value, 0, sizeof(value));
      if(!ParseRecord("bcscanner", "targetbits", value)){
#ifdef _DEBUGGERY
      if(DebugLevel>2)
         printf("Setting bc scanner serial bits to: %s\n", value);
#endif
         if(value!=0){
            sdevBcscanner.bits=atoi(value);
         }
      }
      memset(value, 0, sizeof(value));
		if(!ParseRecord("bcscanner", "targetparity", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting bc scanner serial parity to: %s\n", value);
#endif
         if(value!=0){
            if(strcmp(value, "none")==0){
               y=0;
            }
            else if(strcmp(value, "even")==0){
               y=1;
            }
            else if(strcmp(value, "odd")==0){
               y=2;
            }
            sdevBcscanner.parity=y;
         }
      }
      if(!ParseRecord("bcscanner", "targetstopbits", value)){
#ifdef _DEBUGGERY
      if(DebugLevel>2)
         printf("Setting bc scanner stop bits to: %s\n", value);
#endif
         if(value!=0){
            sdevBcscanner.sbits=atoi(value);
         }
      }
      

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ cash drawer ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */		

		memset(value, 0, sizeof(value));
		if(!ParseRecord("cashdrawer", "devicetype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting cash drawer device type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					dCashd=bhpos::CDDEV_TYPE_NONE;
				}
				else if(strcmp(value, "serial")==0){
					dCashd=bhpos::CDDEV_TYPE_SERIAL;
				}
            else if(strcmp(value, "smartserial")==0){
					dCashd=bhpos::CDDEV_TYPE_SMARTSERIAL;
				}
				else if(strcmp(value, "printer")==0){
					dCashd=bhpos::CDDEV_TYPE_PRINTER;
				}
			}
      }
      
		memset(value, 0, sizeof(value));
		if(!ParseRecord("cashdrawer", "firestring", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting cash drawer firestring to: %s\n", value);
#endif
			if(value!=0){
				fireCashd=value;
			}
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("cashdrawer", "beeponopen", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting cash drawer beep on open: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bcashdbeeponopen=true;
			else
				bcashdbeeponopen=false;
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("cashdrawer", "fireonboot", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting cash drawer fire on boot: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bcashdfireonboot=true;
			else
				bcashdfireonboot=false;
		}

 
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ custdisp ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

		memset(value, 0, sizeof(value));
		if(!ParseRecord("custdisp", "devicetype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting customer display device type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					dCustdisp=bhpos::CPDEV_TYPE_NONE;
				}
				else if(strcmp(value, "printer")==0){
					dCustdisp=bhpos::CPDEV_TYPE_PRINTER;
				}
				else if(strcmp(value, "serial")==0){
					dCustdisp=bhpos::CPDEV_TYPE_SERIAL;
				}
			}
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("custdisp", "type", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting cash drawer type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "character")==0){
					y=0;
				}
				else if(strcmp(value, "device")==0){
					y=1;
				}
			}
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("custdisp", "xsize", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting customer display xsize to: %d\n", atoi(value));
#endif
			y=atoi(value);
         xsizeCustdisp=y;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("custdisp", "ysize", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting customer display ysize to: %d\n", atoi(value));
#endif
			y=atoi(value);
         ysizeCustdisp=y;
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("custdisp", "reverttimer", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting customer display revert timer to: %d\n", atoi(value));
#endif
			y=atoi(value);
         reverttimerCustdisp=y;
		}

      /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ printer ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "devicetype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer device type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					dPrinter=bhpos::PRNDEV_TYPE_NONE;
				}
				else if(strcmp(value, "serial")==0){
					dPrinter=bhpos::PRNDEV_TYPE_SERIAL;
				}
				else if(strcmp(value, "parallel")==0){
					dPrinter=bhpos::PRNDEV_TYPE_PARALLEL;
				}
           else if(strcmp(value, "usb")==0){
					dPrinter=bhpos::PRNDEV_TYPE_USB;
				}
           else if(strcmp(value, "network")==0){
					dPrinter=bhpos::PRNDEV_TYPE_NETWORK;
				}
			}
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "targetdevice", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer device to: %s\n", value);
#endif
			if(value!=0){
            devPrinter=value;
			}
		}
      memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "targetspeed", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer serial speed to: %s\n", value);
#endif
			if(value!=0){
            sdevPrinter.speed=atoi(value);
			}
		}
      memset(value, 0, sizeof(value));
      if(!ParseRecord("printer", "targetbits", value)){
#ifdef _DEBUGGERY
      if(DebugLevel>2)
         printf("Setting printer serial bits to: %s\n", value);
#endif
         if(value!=0){
            sdevPrinter.bits=atoi(value);
         }
      }
      memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "targetparity", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer serial parity to: %s\n", value);
#endif
         if(value!=0){
            if(strcmp(value, "none")==0){
               y=0;
            }
            else if(strcmp(value, "even")==0){
               y=1;
            }
            else if(strcmp(value, "odd")==0){
               y=2;
            }
            sdevPrinter.parity=y;
         }
      }
      if(!ParseRecord("printer", "targetstopbits", value)){
#ifdef _DEBUGGERY
      if(DebugLevel>2)
         printf("Setting printer stop bits to: %s\n", value);
#endif
         if(value!=0){
            sdevPrinter.sbits=atoi(value);
         }
      }
      
      
		/*
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "configfile", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer config file to: %s\n", value);
#endif
			if(value!=0){
				strcpy(x, value);
				//post->SetOption(BH_POST_OPTION_DEV_PRINTER_CONFIG, x);
			}
		}
		
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "layoutfile", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer layout file to: %s\n", value);
#endif
			if(value!=0){
				strcpy(x, value);
				//post->SetOption(BH_POST_OPTION_DEV_PRINTER_LAYOUT, x);
			}
		}*/
      memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "charset", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting prn charset to: %d\n", atoi(value));
#endif
			charset=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "xres", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting rec x res: %d\n", atoi(value));
#endif
			prn_xres=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "yres", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting rec y res to: %d\n", atoi(value));
#endif
			prn_yres=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "reccharline", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting rec char line to: %d\n", atoi(value));
#endif
			reccharline=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "recfont", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting rec font to: %d\n", atoi(value));
#endif
			recfont=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "journalcharline", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting journal char line to: %d\n", atoi(value));
#endif
			jrncharline=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "journalfont", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting journal font to: %d\n", atoi(value));
#endif
			jrnfont=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "slipcharline", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting slip char line to: %d\n", atoi(value));
#endif
			slipcharline=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "slipfont", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting slip font to: %d\n", atoi(value));
#endif
			slipfont=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "nvramsize", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting slip font to: %d\n", atoi(value));
#endif
			nvramsize=atoi(value);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "pagemodecaps", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer pagemode caps to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bPageModeCaps=true;
			else
				bPageModeCaps=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "barcodecaps", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer barcode caps to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bBarcodeCaps=true;
			else
				bBarcodeCaps=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "autocutter", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer autocutter caps to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bAutoCutter=true;
			else
				bAutoCutter=false;
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("printer", "defaultchk", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting def chk to: %d\n", atoi(value));
#endif
			defaultcheque=atoi(value);
		}
		if(!ParseRecord("printer", "autocustdisp", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting printer autocustdisp caps to: %s\n", value);
#endif
			if(*value=='Y' || *value=='y')
				bAutoPole=true;
			else
				bAutoPole=false;
		}
      
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ magswipe ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

		memset(value, 0, sizeof(value));
		if(!ParseRecord("magswipe", "devicetype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting magswipe device type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					dMagswipe=bhpos::MSDEV_TYPE_NONE;
				}
				else if(strcmp(value, "serial")==0){
					dMagswipe=bhpos::MSDEV_TYPE_SERIAL;
				}
				else if(strcmp(value, "keyboard")==0){
					dMagswipe=bhpos::MSDEV_TYPE_KEYBOARD;
				}
			}
		}
		
		memset(value, 0, sizeof(value));
		if(!ParseRecord("magswipe", "configfile", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting magswipe config file to: %s\n", value);
#endif
			if(value!=0){
				//strcpy(x, value);
				//post->SetOption(BH_POST_OPTION_DEV_MAGSWIPE_CONFIG, x);
			}
		}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ micr ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */		
/*
		memset(value, 0, sizeof(value));
		if(!ParseRecord("micr", "devicetype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting micr device type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					y=POST_MICR_NONE;
					//post->SetOption(BH_POST_OPTION_DEV_MICR, &y);
				}
				else if(strcmp(value, "device")==0){
					y=POST_MICR_DEVICE;
					//post->SetOption(BH_POST_OPTION_DEV_MICR, &y);
				}
				else if(strcmp(value, "printer")==0){
					y=POST_MICR_PRINTER;
					//post->SetOption(BH_POST_OPTION_DEV_MICR, &y);
				}
			}
		}
		
		memset(value, 0, sizeof(value));
		if(!ParseRecord("micr", "configfile", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting micr config file to: %s\n", value);
#endif
			if(value!=0){
				strcpy(x, value);
				//post->SetOption(BH_POST_OPTION_DEV_MICR_CONFIG, x);
			}
		}		
*/
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ smart card ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */		
/*
		memset(value, 0, sizeof(value));
		if(!ParseRecord("smartcard", "devicetype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting smartcard device type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					y=POST_SMARTCARD_NONE;
					//post->SetOption(BH_POST_OPTION_DEV_SMARTC, &y);
				}
				else if(strcmp(value, "device")==0){
					y=POST_SMARTCARD_DEVICE;
					//post->SetOption(BH_POST_OPTION_DEV_SMARTC, &y);
				}
				else if(strcmp(value, "keyboard")==0){
					y=POST_SMARTCARD_KEYB;
					//post->SetOption(BH_POST_OPTION_DEV_SMARTC, &y);
				}
			}
		}
		
		memset(value, 0, sizeof(value));
		if(!ParseRecord("smartcard", "configfile", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting smartcard config file to: %s\n", value);
#endif
			if(value!=0){
				strcpy(x, value);
				//post->SetOption(BH_POST_OPTION_DEV_SMARTC_CONFIG, x);
			}
		}
*/
		/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ scales ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */		
/*
		memset(value, 0, sizeof(value));
		if(!ParseRecord("scales", "devicetype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting scales device type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					y=POST_SCALES_NONE;
					//post->SetOption(BH_POST_OPTION_DEV_SCALES, &y);
				}
				else if(strcmp(value, "device")==0){
					y=POST_SCALES_DEVICE;
					//post->SetOption(BH_POST_OPTION_DEV_SCALES, &y);
				}
			}
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("scales", "protocol", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting scale protocol to: %d\n", atoi(value));
#endif
			y=atoi(value);
			//post->SetOption(BH_POST_OPTION_SCALES_PROTOCOL, &y);
		}
*/
		/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ tablet ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */		
/*
		memset(value, 0, sizeof(value));
		if(!ParseRecord("tablet", "devicetype", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tablet device type to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					y=POST_TABLET_NONE;
					//post->SetOption(BH_POST_OPTION_DEV_TABLET, &y);
				}
				else if(strcmp(value, "device")==0){
					y=POST_TABLET_DEVICE;
					//post->SetOption(BH_POST_OPTION_DEV_TABLET, &y);
				}
			}
		}
		
		memset(value, 0, sizeof(value));
		if(!ParseRecord("tablet", "xstart", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tablet xstart to: %d\n", atoi(value));
#endif
			y=atoi(value);
			//post->SetOption(BH_POST_OPTION_TABLET_XSTART, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("tablet", "xend", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tablet xend to: %d\n", atoi(value));
#endif
			y=atoi(value);
			//post->SetOption(BH_POST_OPTION_TABLET_XEND, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("tablet", "ystart", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tablet ystart to: %d\n", atoi(value));
#endif
			y=atoi(value);
			//post->SetOption(BH_POST_OPTION_TABLET_YSTART, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("tablet", "yend", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tablet yend to: %d\n", atoi(value));
#endif
			y=atoi(value);
			//post->SetOption(BH_POST_OPTION_TABLET_YEND, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("tablet", "logicalxsize", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tablet logicalxsize to: %d\n", atoi(value));
#endif
			y=atoi(value);
			//post->SetOption(BH_POST_OPTION_TABLET_LOGXSIZE, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("tablet", "logicalysize", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tablet logicalysize to: %d\n", atoi(value));
#endif
			y=atoi(value);
			//post->SetOption(BH_POST_OPTION_TABLET_LOGYSIZE, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("tablet", "numfilterpoints", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tablet logicalxsize to: %d\n", atoi(value));
#endif
			y=atoi(value);
			//post->SetOption(BH_POST_OPTION_TABLET_NUMFILT, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("tablet", "format", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting tablet logicalxsize to: %d\n", atoi(value));
#endif
			y=atoi(value);
			//post->SetOption(BH_POST_OPTION_TABLET_FORMAT, &y);
		}
*/
		/*~~~~~~~~~~~~~~~~~~~~~~~ Lite Options ~~~~~~~~~~~~~~~~~~~~~~~~ */
/*
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial0", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial0 to: %s\n", value);
#endif
         y=atoi(value);
   		//post->SetOption(BH_POST_OPTION_DEVS0, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial0speed", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial0 speed to: %s\n", value);
#endif
         y=atoi(value);
   		//post->SetOption(BH_POST_OPTION_DEVS0_SPEED, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial0bits", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial0 bits to: %s\n", value);
#endif
         y=atoi(value);
   		//post->SetOption(BH_POST_OPTION_DEVS0_BITS, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial0parity", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial0 parity to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					y=0;
					//post->SetOption(BH_POST_OPTION_DEVS0_PARITY, &y);
				}
				else if(strcmp(value, "even")==0){
					y=1;
					//post->SetOption(BH_POST_OPTION_DEVS0_PARITY, &y);
				}
				else if(strcmp(value, "odd")==0){
					y=2;
					//post->SetOption(BH_POST_OPTION_DEVS0_PARITY, &y);
				}
         }
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial0stopbits", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial0 stop bits to: %s\n", value);
#endif
         y=atoi(value);
   		//post->SetOption(BH_POST_OPTION_DEVS0_SBITS, &y);
		}
		
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial1", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial1 to: %s\n", value);
#endif
         y=atoi(value);
   		//post->SetOption(BH_POST_OPTION_DEVS1, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial1speed", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial1 speed to: %s\n", value);
#endif
         y=atoi(value);
   		//post->SetOption(BH_POST_OPTION_DEVS1_SPEED, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial1 bits", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial1 bits to: %s\n", value);
#endif
         y=atoi(value);
   		//post->SetOption(BH_POST_OPTION_DEVS1_BITS, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial1parity", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial1 parity to: %s\n", value);
#endif
			if(value!=0){
				if(strcmp(value, "none")==0){
					y=0;
					//post->SetOption(BH_POST_OPTION_DEVS1_PARITY, &y);
				}
				else if(strcmp(value, "even")==0){
					y=1;
					//post->SetOption(BH_POST_OPTION_DEVS1_PARITY, &y);
				}
				else if(strcmp(value, "odd")==0){
					y=2;
					//post->SetOption(BH_POST_OPTION_DEVS1_PARITY, &y);
				}
         }
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "serial1stopbits", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device serial1 stop bits to: %s\n", value);
#endif
         y=atoi(value);
   		//post->SetOption(BH_POST_OPTION_DEVS1_SBITS, &y);
		}
		memset(value, 0, sizeof(value));
		if(!ParseRecord("device", "parallel0", value)){
#ifdef _DEBUGGERY
			if(DebugLevel>2)
				printf("Setting device parallel0 to: %s\n", value);
#endif
         y=atoi(value);
			//post->SetOption(BH_POST_OPTION_DEVP0, &y);
		}*/
	}
   return 0;
}

int CMfConfig::SetOption(BhMfConfig c, void *v)
{
if(v==NULL) return -1;
   
   switch(c){
   case MFENG_CONFIG_DEBUGLEVEL:
      break;
   case MFENG_CONFIG_PROTOCOLUDP:
      break;
   case MFENG_CONFIG_PROTOCOLTCP:
       bTcp = *((bool *) v);
      break;
   case MFENG_CONFIG_HOST:
      if(shost!="") shost="";
      shost=(char *) v;
      break;
   case MFENG_CONFIG_PORT:
      sport=*((unsigned short *) v);
      break;
   case MFENG_CONFIG_MCHOST:
      if(chost!="") chost="";
      chost=(char *) v;
      break;
   case MFENG_CONFIG_MCPORT:
      cport=*((unsigned short *) v);
      break;
   case MFENG_CONFIG_UPLUPOLICY:
      plupolicy=*((int *) v);
      break;
   case MFENG_CONFIG_ALPHAPLU:
      bAlphaplu=*((bool *) v);
      break;
   case MFENG_CONFIG_CONFIRMPOLICY:
      bConfirmPolicy= *((bool *) v);
      break;
   /*
   case MFENG_CONFIG_ALLOWUSER:
      bAllowUser=*((bool *) v);
      break;
   case MFENG_CONFIG_ALLOWSUPER:
      bAllowSupervisor=*((bool *) v);
      break;
   case MFENG_CONFIG_ALLOWMANAGER:
      bAllowManager=*((bool *) v);
      break;
   case MFENG_CONFIG_ALLOWADMIN:
      bAllowAdmin=*((bool *) v);
      break;*/
   case MFENG_CONFIG_LOGOUTEACHTRANS:
      bLogoutEveryTrans=*((bool *) v);
      break;
   case MFENG_CONFIG_ALLOWPASSIVERETURNS:
      bAllowPassiveReturns=*((bool *) v);
      break;
   case  MFENG_CONFIG_CONFIRMCOMMIT:
   	bConfirmCommit=*((bool *) v);
   	break;
   case MFENG_CONFIG_NUMCAT:
      //SetCurrency((char *) v);
      break;
   case MFENG_CONFIG_LANG:
      //SetLocale((char *) v);
      break;
   /*
   case MFENG_CONFIG_PFPOLICY:
      powerfailpolicy=*((int *) v);
      break;
   case MFENG_CONFIG_PFTIMEOUT:
      powerfailtimeout=*((int *) v);
      break;
   case MFENG_CONFIG_REQRETRIES:
      requestretries=*((int *) v);
      break;
   case MFENG_CONFIG_SDPOLICY:
      shutdownpolicy=*((int *) v);
      break;
   case MFENG_CONFIG_AUTHENTICATION:
      authentification=*((int *) v);
      break;
   case MFENG_CONFIG_ENCRYPTION:
      encryption=*((int *) v);
      break;
   case MFENG_CONFIG_SESSDEFAULT:
      sessiondefault=*((int *) v);
      break;
   case MFENG_CONFIG_SESSTIMEOUT:
      sessiontimeout=*((int *) v);
      break;*/
   case MFENG_CONFIG_TRANSMULTIOPEN:
      bTransMulti=*((bool *) v);
      break;
   case MFENG_CONFIG_TRANSSERVERSIDE:
      bTransServerSide=*((bool *) v);
      break;
   case MFENG_CONFIG_AUTODROPTIMEOUT:
      AutoDropTimeout=*((int *) v);
      break;
   case MFENG_CONFIG_TRANSMULTIASSIGNED:
      bTransAssigned=*((bool *) v);
      break;
   case MFENG_CONFIG_TRANSAUTHCASH:
      bAuthCash=*((bool *) v);
      break;
   case MFENG_CONFIG_TRANSAUTHCASHLIMIT:
      authcashlimit=*((int *) v);
      break;
   case MFENG_CONFIG_TRANSHISTORYSTACKSIZE:
      trans_history_stacksize=*((int *) v);
      break;
   case MFENG_CONFIG_TRANSPLUTIMEOUT:
      plutimeout=*((int *) v);
      break;
   case MFENG_CONFIG_EXTERNCREDIT:
     bExternCredit=*((bool *) v);
     break;
   case MFENG_CONFIG_TAXINCLUSIVE:
     bTaxInclusive=*((bool *) v);
     break;
   case MFENG_CONFIG_BLINDRETRIES:
     numbbretries=*((int *) v);
     break;
   case MFENG_CONFIG_MULTIPLESALEPRICE:
     bMultiPrice=*((bool *) v);
     break;  
   case MFENG_CONFIG_MULTIPLETAXUPLU:
     bMultiTax=*((bool *) v);
     break;
   case MFENG_CONFIG_DRAWERPOLICY:
     bDrawerPolicy=*((bool *) v);
     break;
   case MFENG_CONFIG_RETURNSINSALE:
     bReturnInSale=*((bool *) v);
     break;
   case MFENG_CONFIG_RETURNREASON:
     bReturnReason=*((bool *) v);
     break;
   case MFENG_CONFIG_MODAL:
     bModal=*((bool *) v);
     break;
   case MFENG_CONFIG_NOMOUSE:
      bDisappearMouse=*((bool *) v);
      break;
   case MFENG_CONFIG_NOCLOSE:
      bNoClose=*((bool *) v);
      break;
   case MFENG_CONFIG_NOMINIMIZE:
      bNoMinimize=*((bool *) v);
      break;
   case MFENG_CONFIG_STICK:
      bStick=*((bool *) v);
      break;
   case MFENG_CONFIG_DECORATED:
      bDecorated=*((bool *) v);
      break;
   
   case MFENG_CONFIG_SMARTBAR:
      smartbarpos=*((int *) v);
      break;
   case MFENG_CONFIG_SMARTBARTYPE:
      smartbartype=*((int *) v);
      break;
   case MFENG_CONFIG_SMARTBARHOWKEYS:
      bSmartbarshowkeys=*((bool *) v);
      break;
   case MFENG_CONFIG_KEYPAD:
      keypad=*((int *) v);
      break;
   case MFENG_CONFIG_KEYBOARD:
      keyboard=*((int *) v);
      break;
   
   case MFENG_CONFIG_BLINDBALATLOGOUT:
      bBlindBalAtlogout=*((bool *) v);
      break;
   case MFENG_CONFIG_ZTAPEATLOGOUT:
      bZtapeAlogout=*((bool *) v);
      break;
   case MFENG_CONFIG_CASHSALE:  
      bCashSale=*((bool *) v);
      break;
   case MFENG_CONFIG_CASHDRESETTLOGIN:  
      bCashdResetAtlogin=*((bool *) v);
      break;
   
   case MFENG_CONFIG_CUSTOMERADD:
      bCustomerAdd=*((bool *) v);
      break;
   case MFENG_CONFIG_PLUMIN:
      bPluMinimum=*((bool *) v);
      break;
   case MFENG_CONFIG_CHARGEACC:
      bChargeAcc=*((bool *) v);
      break;
   case MFENG_CONFIG_CUSTOMERMODE:
      bCustomerMode=*((bool *) v);
      break;

   /*   
   case MFENG_CONFIG_STYLEFILE:
		strncpy(pgui->style_file, (char *) v, 254);
      break;*/

	case MFENG_CONFIG_CASHBACKTYPES:
		break;

	case MFENG_CONFIG_RX_MULTISIGN:
		break;
   
   case MFENG_CONFIG_DISP_XSIZE:
      xsize=*((int *) v);
      break;
   case MFENG_CONFIG_DISP_YSIZE:
      ysize=*((int *) v);
      break;
   case MFENG_CONFIG_PRN_GLOBAL:
      bUseGlobalPrintSettings=*((bool *) v);
      break;
      
   
   case MFENG_CONFIG_PRINTER_XRES:
      prn_xres=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_YRES:
      prn_yres=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_CHARSET:
      charset=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_RECCHARLINE:
      reccharline=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_RECFONT:
      recfont=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_JRNCHARLINE:
      jrncharline=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_JRNFONT:
      jrnfont=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_SLIPCHARLINE:
      slipcharline=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_SLIPFONT:
      slipfont=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_DEFAULTCHK:
      defaultcheque=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_NVRAMSIZE:
      nvramsize=*((int *) v);
      break;
   case MFENG_CONFIG_PRINTER_PAGEMODE:
      bPageModeCaps=*((bool *) v);
      break;   
   case MFENG_CONFIG_PRINTER_BARCODE:
      bBarcodeCaps=*((bool *) v);
      break;
   case MFENG_CONFIG_PRINTER_AUTOCUSTDISP:
      bAutoPole=*((bool *) v);
      break;
   case MFENG_CONFIG_PRINTER_AUTOCUTTER:
      bAutoCutter=*((bool *) v);
      break;
   
/*   
   case MFENG_CONFIG_DEV_MAGSWIPE:
      dMagswipe=*((bhpos::MagSwipeDeviceType *) v);
      break;*/


   //MFENG_CONFIG_CUSTDISP_DEVICE,
   //MFENG_CONFIG_CUSTDISP_AUTO,
   case MFENG_CONFIG_CUSTDISP_DEVTYPE:
      dCustdisp=*((bhpos::CustdispDeviceType *) v);
      break;
   case MFENG_CONFIG_CUSTDISP_LINEX:
      xsizeCustdisp=*((int *) v);
      break;
   case MFENG_CONFIG_CUSTDISP_LINEY:
      ysizeCustdisp=*((int *) v);
      break;
   case MFENG_CONFIG_CUSTDISP_REVERTTIMER:
      reverttimerCustdisp=*((int *) v);
      break;

   //MFENG_CONFIG_CASHDRAWER_DEVICE
   case MFENG_CONFIG_CASHDRAWER_DEVTYPE:
      dCashd=*((bhpos::CashdrawerDeviceType *) v);
      break;
   case MFENG_CONFIG_CASHDRAWER_BEEPONOPEN:
      bcashdbeeponopen=*(bool *) v;
      break;
 /*  
   case MFENG_CONFIG_DEV_SCALES:
      dScales=*((bhpos::ScalesDeviceType *) v);
      break;
   case MFENG_CONFIG_SCALES_PROTOCOL:
      break;
   */
   }
   return 0;
}

int CMfConfig::GetOption(BhMfConfig c, void *v)
{
   if(v==NULL) return -1;
   
   switch(c){
   case MFENG_CONFIG_PROTOCOLTCP:
      *((bool *) v) = bTcp;
      break;
   case MFENG_CONFIG_HOST:
      strcpy((char *) v, shost.c_str());
      break;
   case MFENG_CONFIG_PORT:
      *((unsigned short *) v) = sport;
      break;
   case MFENG_CONFIG_MCHOST:
      strcpy((char *) v, chost.c_str());
      break;
      
   case MFENG_CONFIG_NETDEVICE:
      strcpy((char *) v, netdev.c_str());
      break;
      
   case MFENG_CONFIG_MCPORT:
      *((unsigned short *) v) = cport;
      break;
   case MFENG_CONFIG_UPLUPOLICY:
      *((int *) v)=plupolicy;
      break;
   case MFENG_CONFIG_ALPHAPLU:
      *((bool *) v)=bAlphaplu;
      break;
   case MFENG_CONFIG_CONFIRMPOLICY:
      *((bool *) v)=bConfirmPolicy;
      break;
   case MFENG_CONFIG_DISP_XSIZE:
      *((int *) v)=xsize;
      break;
   case MFENG_CONFIG_DISP_YSIZE:
      *((int *) v)=ysize;
      break;
   /*
   case MFENG_CONFIG_NOLOGIN:
      *((bool *) v)=bNoLogin;
      break;
   case MFENG_CONFIG_USERNAME:
      strcpy((char *) v, userlogin.c_str());
      break;
   case MFENG_CONFIG_PASSWORD:
      strcpy((char *) v, password.c_str());
      break;
   case MFENG_CONFIG_ALLOWUSER:
      *((bool *) v)=bAllowUser;
      break;
   case MFENG_CONFIG_ALLOWSUPER:
      *((bool *) v)=bAllowSupervisor;
      break;
   case MFENG_CONFIG_ALLOWMANAGER:
      *((bool *) v)=bAllowManager;
      break;
   case MFENG_CONFIG_ALLOWADMIN:
      *((bool *) v)=bAllowAdmin;
      break;*/
   case MFENG_CONFIG_LOGOUTEACHTRANS:
      *((bool *) v)=bLogoutEveryTrans;
      break;
   case MFENG_CONFIG_ALLOWPASSIVERETURNS:
      *((bool *) v)=bAllowPassiveReturns;
      break;
   case  MFENG_CONFIG_CONFIRMCOMMIT:
   	*((bool *) v)=bConfirmCommit;
   	break;
   /*
   case MFENG_CONFIG_PFPOLICY:
      *((int *) v)=powerfailpolicy;
      break;
   case MFENG_CONFIG_PFTIMEOUT:
      *((int *) v)=powerfailtimeout;
      break;
   case MFENG_CONFIG_REQRETRIES:
      *((int *) v)=requestretries;
      break;
   case MFENG_CONFIG_SDPOLICY:
      *((int *) v)=shutdownpolicy;
      break;
   case MFENG_CONFIG_AUTHENTICATION:
      *((int *) v)=authentification;
      break;
   case MFENG_CONFIG_ENCRYPTION:
      *((int *) v)=encryption;
      break;
   case MFENG_CONFIG_SESSDEFAULT:
      *((int *) v)=sessiondefault;
      break;
   case MFENG_CONFIG_SESSTIMEOUT:
      *((int *) v)=sessiontimeout;
      break;*/
   case MFENG_CONFIG_TRANSMULTIOPEN:
      *((bool *) v)=bTransMulti;
      break;
   case MFENG_CONFIG_TRANSSERVERSIDE:
      *((bool *) v)=bTransServerSide;
      break;
   case MFENG_CONFIG_AUTODROPTIMEOUT:
      *((int *) v)=AutoDropTimeout;
      break;
   case MFENG_CONFIG_TRANSMULTIASSIGNED:
      *((bool *) v)=bTransAssigned;
      break;
   case MFENG_CONFIG_TRANSAUTHCASH:
      *((bool *) v)=bAuthCash;
      break;
   case MFENG_CONFIG_TRANSAUTHCASHLIMIT:
      *((int *) v)=authcashlimit;
      break;
   case MFENG_CONFIG_TRANSHISTORYSTACKSIZE:
      *((int *) v)=trans_history_stacksize;
      break;
   case MFENG_CONFIG_TRANSPLUTIMEOUT:
      *((int *) v)=plutimeout;
      break;
   case MFENG_CONFIG_EXTERNCREDIT:
      *((bool *) v)=bExternCredit;
      break;
   case MFENG_CONFIG_TAXINCLUSIVE:
     *((bool *) v)=bTaxInclusive;
     break;
  case MFENG_CONFIG_BLINDRETRIES:
     *((int *) v)=numbbretries;
     break;
   case MFENG_CONFIG_MULTIPLESALEPRICE:
     *((bool *) v)=bMultiPrice;
     break;  
   case MFENG_CONFIG_MULTIPLETAXUPLU:
     *((bool *) v)=bMultiTax;
     break;
   case MFENG_CONFIG_DRAWERPOLICY:
     *((bool *) v)=bDrawerPolicy;
     break;
   case MFENG_CONFIG_RETURNSINSALE:
     *((bool *) v)=bReturnInSale;
     break;
   case MFENG_CONFIG_RETURNREASON:
     *((bool *) v)=bReturnReason;
     break;
   case MFENG_CONFIG_WEIGHTBCPREFIX:
      *((int *) v)=bc_prefix.weight_prefix;
      break;
   case MFENG_CONFIG_QTYBCPREFIX:
      *((int *) v)=bc_prefix.quantity_prefix;
      break;
   case MFENG_CONFIG_IFBCPREFIX:
      *((int *) v)=bc_prefix.interface_prefix;
      break;
   case MFENG_CONFIG_PRICEBCPREFIX:
      *((int *) v)=bc_prefix.price_prefix;
      break;
   case MFENG_CONFIG_TOKENBCPREFIX:
      *((int *) v)=bc_prefix.token_prefix;
      break;
   case MFENG_CONFIG_VOUCHERBCPREFIX:
      *((int *) v)=bc_prefix.voucher_prefix;
      break;
   case MFENG_CONFIG_CUSTOMERBCPREFIX:
      *((int *) v)=bc_prefix.customer_prefix;
      break;
   case MFENG_CONFIG_INTBCPREFIX:
      *((int *) v)=bc_prefix.instore_prefix;
      break;
   case MFENG_CONFIG_MODAL:
     *((bool *) v)=bModal;
     break;
   case MFENG_CONFIG_NOMOUSE:
      *((bool *) v)=bDisappearMouse;
     break;
   case MFENG_CONFIG_NOCLOSE:
      *((bool *) v)=bNoClose;
      break;
   case MFENG_CONFIG_NOMINIMIZE:
      *((bool *) v)=bNoMinimize;
      break;
   case MFENG_CONFIG_STICK:
      *((bool *) v)=bStick;
      break;
   case MFENG_CONFIG_DECORATED:
      *((bool *) v)=bDecorated;
      break;
   case MFENG_CONFIG_IMAGEDIR:
      if(v==NULL){
         printf("cmfconfig::null pointer\n");
      }
      strncpy((char *) v, imagedir.data(), 255);
      break;
   
   case MFENG_CONFIG_SMARTBAR:
      *((int *) v)=smartbarpos;
      break;
   case MFENG_CONFIG_SMARTBARTYPE:
      *((int *) v)=smartbartype;
      break;
   case MFENG_CONFIG_SMARTBARHOWKEYS:
      *((bool *) v)=bSmartbarshowkeys;
      break;
   case MFENG_CONFIG_KEYPAD:
      *((int *) v)=keypad;
      break;
   case MFENG_CONFIG_KEYBOARD:
      *((int *) v)=keyboard;
      break;
   /*
   case MFENG_CONFIG_RNDTYPE:
      *((int *) v)=connection_info.roundtype;
      break;
   case MFENG_CONFIG_RNDUNIT:
      *((float *) v)=connection_info.roundunit;
      break;*/
   case MFENG_CONFIG_BLINDBALATLOGOUT:
      *((bool *) v)=bBlindBalAtlogout;
      break;
   case MFENG_CONFIG_ZTAPEATLOGOUT:
      *((bool *) v)=bZtapeAlogout;
      break;
   case MFENG_CONFIG_CASHSALE:  
      *((bool *) v)=bCashSale;
      break;
   case MFENG_CONFIG_CASHDRESETTLOGIN:  
      *((bool *) v)=bCashdResetAtlogin;
      break;
   
   case MFENG_CONFIG_CUSTOMERADD:
      *((bool *) v)=bCustomerAdd;
      break;
   case MFENG_CONFIG_PLUMIN:
      *((bool *) v)=bPluMinimum;
      break;
   case MFENG_CONFIG_CHARGEACC:
      *((bool *) v)=bChargeAcc;
      break;
   case MFENG_CONFIG_CUSTOMERMODE:
      *((bool *) v)=bCustomerMode;
      break;
   /*
   case MFENG_CONFIG_NUMTAXLIST:
      *((int *) v)=connection_info.numtaxitems;
      break;
   case MFENG_CONFIG_NUMPRICELIST:
      *((int *) v)=connection_info.numpriceitems;
      break;*/
  
   case MFENG_CONFIG_BCSCANNER_DEVTYPE:
      *((bhpos::BarcodeDeviceType *) v)=dBcscanner;
      break;
   case MFENG_CONFIG_BCSCANNER_DEVICE:
      *((Glib::ustring *) v)=devBcscanner;
      break;
   case MFENG_CONFIG_BCSCANNER_SSPEED:
      *((int *) v)=sdevBcscanner.speed;
      break;
   case MFENG_CONFIG_BCSCANNER_SBITS:
      *((int *) v)=sdevBcscanner.bits;
      break;
   case MFENG_CONFIG_BCSCANNER_SPARITY:
      *((int *) v)=sdevBcscanner.parity;
      break;
   case MFENG_CONFIG_BCSCANNER_SSBITS:
      *((int *) v)=sdevBcscanner.sbits;
      break;
   case MFENG_CONFIG_BCSCANNER_SSENTINEL:
      *((Glib::ustring *) v)=ssBcscanner;
      break;
   case MFENG_CONFIG_BCSCANNER_ESENTINEL:
      *((Glib::ustring *) v)=esBcscanner;
      break;
   
   
   case MFENG_CONFIG_CASHDRAWER_DEVTYPE:
      *((bhpos::CashdrawerDeviceType *) v)=dCashd;
      break;
   case MFENG_CONFIG_CASHDRAWER_DEVICE:
      *((Glib::ustring *) v)=devCashd;
      break;
   case MFENG_CONFIG_CASHDRAWER_BEEPONOPEN:
      *((bool *) v) =bcashdbeeponopen;
      break;
   case MFENG_CONFIG_CASHDRAWER_FIREONBOOT:
      *((bool *) v) =bcashdfireonboot;
      break;
   
   
   case MFENG_CONFIG_PRINTER_DEVTYPE:
      *((bhpos::PrinterDeviceType *) v)=dPrinter;
      break;
   case MFENG_CONFIG_PRINTER_DEVICE:
      *((Glib::ustring *) v)=devPrinter;
      break;
   case MFENG_CONFIG_PRINTER_SSPEED:
      *((int *) v)=sdevPrinter.speed;
      break;
   case MFENG_CONFIG_PRINTER_SBITS:
      *((int *) v)=sdevPrinter.bits;
      break;
   case MFENG_CONFIG_PRINTER_SPARITY:
      *((int *) v)=sdevPrinter.parity;
      break;
   case MFENG_CONFIG_PRINTER_SSBITS:
      *((int *) v)=sdevPrinter.sbits;
      break;  
   case MFENG_CONFIG_PRINTER_XRES:
      *((int *) v)=prn_xres;
      break;
   case MFENG_CONFIG_PRINTER_YRES:
      *((int *) v)=prn_yres;
      break;
   case MFENG_CONFIG_PRINTER_CHARSET:
      *((int *) v)=charset;
      break;
   case MFENG_CONFIG_PRINTER_RECCHARLINE:
      *((int *) v)=reccharline;
      break;
   case MFENG_CONFIG_PRINTER_RECFONT:
      *((int *) v)=recfont;
      break;
   case MFENG_CONFIG_PRINTER_JRNCHARLINE:
      *((int *) v)=jrncharline;
      break;
   case MFENG_CONFIG_PRINTER_JRNFONT:
      *((int *) v)=jrnfont;
      break;
   case MFENG_CONFIG_PRINTER_SLIPCHARLINE:
      *((int *) v)=slipcharline;
      break;
   case MFENG_CONFIG_PRINTER_SLIPFONT:
      *((int *) v)=slipfont;
      break;
   case MFENG_CONFIG_PRINTER_DEFAULTCHK:
      *((int *) v)=defaultcheque;
      break;
   case MFENG_CONFIG_PRINTER_NVRAMSIZE:
      *((int *) v)=nvramsize;
      break;
   case MFENG_CONFIG_PRINTER_PAGEMODE:
      *((bool *) v)=bPageModeCaps;
      break; 
   case MFENG_CONFIG_PRINTER_BARCODE:
      *((bool *) v)=bBarcodeCaps;
      break;
   case MFENG_CONFIG_PRINTER_AUTOCUSTDISP:
      *((bool *) v)=bAutoPole;
      break;
/*
   case MFENG_CONFIG_DEV_MAGSWIPE:
      *((bhpos::MagSwipeDeviceType *) v)=dMagswipe;
      break;
   case MFENG_CONFIG_DEV_MAGSWIPE_CONFIG:
      strcpy((char *) v, cfgMagswipe.c_str());
      break;*/

   case MFENG_CONFIG_CUSTDISP_DEVTYPE:
      *((bhpos::CustdispDeviceType *) v)=dCustdisp;
      break;
   case MFENG_CONFIG_CUSTDISP_LINEX:
      *((int *) v)=xsizeCustdisp;
      break;
   case MFENG_CONFIG_CUSTDISP_LINEY:
      *((int *) v)=ysizeCustdisp;
      break;
   case MFENG_CONFIG_CUSTDISP_REVERTTIMER:
      *((int *) v)=reverttimerCustdisp;
      break;

   /*
   case MFENG_CONFIG_DEV_CUSTDISP_TYPE:
      *((int *) v)=custdisptype;
      break;
   case MFENG_CONFIG_DEV_CUSTDISP_CONFIG:
      strcpy((char *) v, cfgCustdisp.c_str());
      break;
   
   case MFENG_CONFIG_DEV_SCALES:
      *((bhpos::ScalesDeviceType *) v)=dScales;
      break;
      
   case MFENG_CONFIG_DEV_MICR:
      *((int *) v)=dMicr;
      break;
   case MFENG_CONFIG_DEV_MICR_CONFIG:
      strcpy((char *) v, cfgMicr.c_str());
      break;
   
   case MFENG_CONFIG_DEV_SMARTC:
      *((int *) v)=dSmartcard;
      break;
   case MFENG_CONFIG_DEV_SMARTC_CONFIG:
      strcpy((char *) v, cfgSmartcard.c_str());
      break;*/
   }
   return 0;
}
