/*
mfconfig.h
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
*/

#ifndef _MFCONFIG_
#define _MFCONFIG_

#include <glibmm/ustring.h>

#include <pos.h>
//#include <postdev.h>
#include <cfg.h>
#include <bhhardware.h>

/**
 * @defgroup bhmfconfig Configuration
 * @{
 *
 * @ingroup mfengine
 * @{	
 */

/*! \enum BhMfConfig
    \brief The config parameter.
*/
enum BhMfConfig{
   MFENG_CONFIG_DEBUGLEVEL,
   MFENG_CONFIG_PROTOCOLUDP,
   MFENG_CONFIG_PROTOCOLTCP,
   MFENG_CONFIG_HOST,
   MFENG_CONFIG_PORT,
   MFENG_CONFIG_MCHOST,
   MFENG_CONFIG_MCPORT,
   MFENG_CONFIG_NETDEVICE,
   MFENG_CONFIG_MACADDRESS,
   MFENG_CONFIG_DISP_XSIZE,
   MFENG_CONFIG_DISP_YSIZE,
   MFENG_CONFIG_KEYREDIRECTION,
   MFENG_CONFIG_NUMMENUHEADINGS,
   MFENG_CONFIG_MENUHEADING,
   MFENG_CONFIG_NUMMENUITEMS,
   MFENG_CONFIG_MENUITEM,
   MFENG_CONFIG_NOLOGIN,
   MFENG_CONFIG_USERNAME,
   MFENG_CONFIG_PASSWORD,
   MFENG_CONFIG_LOGOUTEACHTRANS,       //! Passive mode - logs user out after every transaction
   
   /*
   MFENG_CONFIG_ALLOWUSER,
   MFENG_CONFIG_ALLOWSUPER,
   MFENG_CONFIG_ALLOWMANAGER,
   MFENG_CONFIG_ALLOWADMIN,
   MFENG_CONFIG_PFPOLICY,
   MFENG_CONFIG_PFTIMEOUT,
   MFENG_CONFIG_REQRETRIES,
   MFENG_CONFIG_SDPOLICY,
   MFENG_CONFIG_AUTHENTICATION,
   MFENG_CONFIG_ENCRYPTION,
   MFENG_CONFIG_SESSDEFAULT,
   MFENG_CONFIG_SESSTIMEOUT,*/
   MFENG_CONFIG_ALPHAPLU,              //! Allow alpha values (A-Z, a-z) in PLUs
   MFENG_CONFIG_UPLUPOLICY,
   MFENG_CONFIG_CONFIRMPOLICY,         //! Confirm on things like cancel trans, logout, quit, etc
   MFENG_CONFIG_TRANSMULTIOPEN,
   MFENG_CONFIG_TRANSAUTHCASH,
   MFENG_CONFIG_TRANSHISTORYSTACKSIZE,
   MFENG_CONFIG_TRANSAUTHCASHLIMIT,
   MFENG_CONFIG_TRANSPLUTIMEOUT,
   MFENG_CONFIG_ALLOWPASSIVERETURNS,
   MFENG_CONFIG_EXTERNCREDIT,
   MFENG_CONFIG_MULTIPLESALEPRICE,
   MFENG_CONFIG_MULTIPLETAXUPLU,
   MFENG_CONFIG_DRAWERPOLICY,
   MFENG_CONFIG_WEIGHTBCPREFIX,
   MFENG_CONFIG_QTYBCPREFIX,
   MFENG_CONFIG_IFBCPREFIX,
   MFENG_CONFIG_PRICEBCPREFIX,
   MFENG_CONFIG_TOKENBCPREFIX,
   MFENG_CONFIG_VOUCHERBCPREFIX,
   MFENG_CONFIG_CUSTOMERBCPREFIX,
   MFENG_CONFIG_INTBCPREFIX,
   MFENG_CONFIG_RETURNSINSALE,
   MFENG_CONFIG_BLINDRETRIES,
   
   MFENG_CONFIG_MODAL,                 //! If set, cannot defocus
   MFENG_CONFIG_NOMOUSE,               //! Hides cursor, ignores mouse events
   MFENG_CONFIG_NOCLOSE,               //! Stops close
   MFENG_CONFIG_NOMINIMIZE,            //! Stops minimize
   MFENG_CONFIG_STICK,                 //! On all workspaces
   MFENG_CONFIG_DECORATED,             //! Window frame
   MFENG_CONFIG_IMAGEDIR,
   MFENG_CONFIG_COL_DEFFG,
   MFENG_CONFIG_COL_DEFBG,
   MFENG_CONFIG_COL_SELFG,
   MFENG_CONFIG_COL_SELBG,
   MFENG_CONFIG_COL_CELLFG,
   MFENG_CONFIG_COL_PAYBG,
   MFENG_CONFIG_COL_PAYHDR,
   MFENG_CONFIG_COL_PAYLIST,
   MFENG_CONFIG_COL_UPLUFG,
   MFENG_CONFIG_COL_PLULUFG,
   MFENG_CONFIG_COL_RETFG,
   MFENG_CONFIG_COL_LBFG,
   MFENG_CONFIG_COL_RENTFG,
   MFENG_CONFIG_COL_EPHFG,
   MFENG_CONFIG_STYLEFILE,
   
   MFENG_CONFIG_SMARTBAR,
   MFENG_CONFIG_SMARTBARTYPE,
   MFENG_CONFIG_SMARTBARHOWKEYS,
   MFENG_CONFIG_KEYPAD,
   MFENG_CONFIG_KEYBOARD,
   MFENG_CONFIG_CUSTOMERADD,
   MFENG_CONFIG_PLUMIN,
   MFENG_CONFIG_CHARGEACC,
   MFENG_CONFIG_CUSTOMERMODE,
   
   MFENG_CONFIG_TAXINCLUSIVE,
   MFENG_CONFIG_CASHBACKTYPES,
   MFENG_CONFIG_RX_MULTISIGN,
   MFENG_CONFIG_PRN_GLOBAL,
   MFENG_CONFIG_NUMTAXLIST,
   MFENG_CONFIG_NUMPRICELIST,
   MFENG_CONFIG_NUMCAT,
   MFENG_CONFIG_LANG,
   MFENG_CONFIG_CONFIRMCOMMIT,
   MFENG_CONFIG_CASHSALE,
   MFENG_CONFIG_TRANSMULTIASSIGNED,
   MFENG_CONFIG_TRANSSERVERSIDE,
   MFENG_CONFIG_RETURNREASON,
   MFENG_CONFIG_RNDTYPE,
   MFENG_CONFIG_RNDUNIT,
   MFENG_CONFIG_BLINDBALATLOGOUT,
   MFENG_CONFIG_ZTAPEATLOGOUT,
   MFENG_CONFIG_CASHDRESETTLOGIN,
   MFENG_CONFIG_AUTODROPTIMEOUT,       //! Time to drop trans in Server Side Trans mode
   
   MFENG_CONFIG_BCSCANNER_DEVTYPE,
   MFENG_CONFIG_BCSCANNER_DEVICE,
   MFENG_CONFIG_BCSCANNER_SSPEED,
   MFENG_CONFIG_BCSCANNER_SBITS,
   MFENG_CONFIG_BCSCANNER_SPARITY,
   MFENG_CONFIG_BCSCANNER_SSBITS,
   MFENG_CONFIG_BCSCANNER_SSENTINEL,
   MFENG_CONFIG_BCSCANNER_ESENTINEL,
   
   MFENG_CONFIG_CASHDRAWER_DEVTYPE,
   MFENG_CONFIG_CASHDRAWER_DEVICE,
   MFENG_CONFIG_CASHDRAWER_BEEPONOPEN,
   MFENG_CONFIG_CASHDRAWER_FIREONBOOT,
   
   MFENG_CONFIG_CUSTDISP_DEVTYPE,
   MFENG_CONFIG_CUSTDISP_DEVICE,
   MFENG_CONFIG_CUSTDISP_AUTO,
   MFENG_CONFIG_CUSTDISP_LINEX,
   MFENG_CONFIG_CUSTDISP_LINEY,
   MFENG_CONFIG_CUSTDISP_REVERTTIMER,
   
   MFENG_CONFIG_PRINTER_DEVTYPE,
   MFENG_CONFIG_PRINTER_DEVICE,
   MFENG_CONFIG_PRINTER_SSPEED,
   MFENG_CONFIG_PRINTER_SBITS,
   MFENG_CONFIG_PRINTER_SPARITY,
   MFENG_CONFIG_PRINTER_SSBITS,
   MFENG_CONFIG_PRINTER_CONFIG,
   MFENG_CONFIG_PRINTER_LAYOUT,
   MFENG_CONFIG_PRINTER_XRES,
   MFENG_CONFIG_PRINTER_YRES,
   MFENG_CONFIG_PRINTER_CHARSET,
   MFENG_CONFIG_PRINTER_RECCHARLINE,
   MFENG_CONFIG_PRINTER_RECFONT,
   MFENG_CONFIG_PRINTER_JRNCHARLINE,
   MFENG_CONFIG_PRINTER_JRNFONT,
   MFENG_CONFIG_PRINTER_SLIPCHARLINE,
   MFENG_CONFIG_PRINTER_SLIPFONT,
   MFENG_CONFIG_PRINTER_NVRAMSIZE,
   MFENG_CONFIG_PRINTER_PAGEMODE,
   MFENG_CONFIG_PRINTER_BARCODE,
   MFENG_CONFIG_PRINTER_DEFAULTCHK,
   MFENG_CONFIG_PRINTER_AUTOCUSTDISP,
   MFENG_CONFIG_PRINTER_AUTOCUTTER,
   
   MFENG_CONFIG_MAGSWIPE_DEVTYPE,
   MFENG_CONFIG_MAGSWIPE_DEVICE,
   
   MFENG_CONFIG_SCALES_DEVTYPE,
   MFENG_CONFIG_SCALES_DEVICE

   /*
   MFENG_CONFIG_TABLET_DEVTYPE,
   MFENG_CONFIG_TABLET_XSTART,
   MFENG_CONFIG_TABLET_XEND,
   MFENG_CONFIG_TABLET_YSTART,
   MFENG_CONFIG_TABLET_YEND,
   MFENG_CONFIG_TABLET_LOGXSIZE,
   MFENG_CONFIG_TABLET_LOGYSIZE,
   MFENG_CONFIG_TABLET_NUMFILT,
   MFENG_CONFIG_TABLET_FORMAT*/
};

typedef struct tagTaxList{
   int            numitems;
   BhTaxListItem  *item;
}TaxList;

typedef struct tagPriceList{
   int             numitems;
   BhPriceListItem *item;
}PriceList;

typedef struct tagSDev{
	char flags;
   int  speed;
	char bits;
	char parity;
	char sbits;
}SDev;

class CMfConfig : public BhPos::CConfig
{
private:
   int   xsize;
   int   ysize;
   Glib::ustring style_file;
   bool  bTcp, bUdp;
   bool  bModal;
   bool  bDisappearMouse;
   bool  bNoClose;
   bool  bNoMinimize;
   bool  bStick;
   bool  bDecorated;
   int   smartbarpos;
   int   smartbartype;
   bool  bSmartbarshowkeys;
   int   keypad;
   int   keyboard;
   /*
   bool  bAllowUser;
   bool  bAllowSupervisor;
   bool  bAllowManager;
   bool  bAllowAdmin;*/
   int   AutoDropTimeout;
   bool  bLogoutEveryTrans;
   bool  bAllowPassiveReturns;
   bool  bMultipleSalePrices;
   bool  bConfirmCommit;
   bool  bDrawerPolicy;
   
   bool  bTransMulti;
   bool  bTransServerSide;
   bool  bTransAssigned;
   bool  bAuthCash;
   bool  bExternCredit;
   bool  bMultiPrice;
   bool  bMultiTax;
   bool  bReturnInSale;
   bool  bReturnReason;
   bool  bTaxInclusive;
   int   authcashlimit;
   int   trans_history_stacksize;
   bool  bBlindBalAtlogout;
   bool  bZtapeAlogout;
   bool  bCashdResetAtlogin;
   bool  bCashSale;
   
   bool bCustomerAdd;
   bool bPluMinimum;
   bool bChargeAcc;
   bool bCustomerMode;
   
   int   numbbretries;
   int   plupolicy;
   bool  bConfirmPolicy;

   int   plutimeout;
   int   powerfailpolicy;
   int   powerfailtimeout;
   int   requestretries;
   int   shutdownpolicy;

   /*
   int  custdisptype;
   int  custdisp_x;
   int  custdisp_y;
   */
   Glib::ustring  netdev;
   Glib::ustring  shost;
   unsigned short sport;
   Glib::ustring  chost;
   unsigned short cport;

   int   authentification;
   int   encryption;
   int   sessiondefault;
   int   sessiontimeout;
   bool  bSessionTimeout;
   
   Glib::ustring t_userName;
   int  t_userID;
   int  t_interfaceID;

   int   tcstatus;
   int   tctype;
   
   bool         bUseGlobalPrintSettings;
   bool         bAlphaplu;
   GlobalPrint  print_strings;
   GlobalPrefix bc_prefix;
   
   // devices
   bhpos::BarcodeDeviceType dBcscanner;
   Glib::ustring            devBcscanner;
   Glib::ustring            ssBcscanner;
   Glib::ustring            esBcscanner;
   SDev                     sdevBcscanner;
   
   bhpos::CashdrawerDeviceType dCashd;
   Glib::ustring               devCashd;
   Glib::ustring               fireCashd;
   Glib::ustring               statusCashd;
   bool                        bcashdbeeponopen;
   bool                        bcashdfireonboot;
   SDev                        sdevCashd;
   
   bhpos::CustdispDeviceType   dCustdisp;
   Glib::ustring               devCustdisp;
   int                         typeCustdisp;
   int                         xsizeCustdisp;
   int                         ysizeCustdisp;
   int                         reverttimerCustdisp;
   SDev                        sdevCustdisp;
   
   bhpos::PrinterDeviceType    dPrinter;
   Glib::ustring               devPrinter;
   int  prn_xres;
   int  prn_yres;
   int  charset;
   int  reccharline;
   int  jrncharline;
   int  slipcharline;
   int  recfont;
   int  jrnfont;
   int  slipfont;
   int  defaultcheque;
   int  nvramsize;
   bool bBarcodeCaps;
   bool bPageModeCaps;
   bool bAutoPole;
   bool bAutoCutter;
   SDev                        sdevPrinter;
   
   bhpos::MagSwipeDeviceType   dMagswipe;
   Glib::ustring               devMagswipe;
   SDev                        sdeMagswipe;
   
   bhpos::ScalesDeviceType     dScales;
   Glib::ustring               devScales;
   SDev                        sdevScales;
   
   unsigned int ps2bcprefix;
   unsigned int ps2bcpostfix;
   
   Glib::ustring  imagedir;
   
   TaxList   taxlist;
   PriceList pricelist;

public:
   CMfConfig();
   ~CMfConfig();
   int Parse(char *filename);
   int SetOption(BhMfConfig, void *);
   int GetOption(BhMfConfig, void *);
};

/* }@ */

#endif
