/*
customer.cpp

Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001-2004 Al Kingsley
*/

#include "config.h"
#include <fcntl.h>

#include "pos.h"
#include "bhnetwork.h"
#include "ctransitems.h"
#include "cmfengine.h"

namespace bhmfengine {

int CMfPosEngine::CustomerEvent(BhCustomerEvent type, void *ev)
{
   
   BhPosHdr	        hdr;
   BhPosConnect     c;
   
   memset(&hdr, 0, sizeof(hdr));
   memset(&c, 0, sizeof(c));
   
   switch(type){
   case BHMF_CUSTOMER_BARCODE:
   case BHMF_CUSTOMER_MAGSWIPE:
   {
      BhLogonRequestEx *lor=(BhLogonRequestEx *) ev;
   }
      break;
   case BHMF_CUSTOMER_DETAILS:
   case BHMF_CUSTOMER_ADD:
   case BHMF_CUSTOMER_EDIT:
      break;
   }
   /*
   hdr.hdr.type=BHPOS_TYPE_SYSTEM;
   hdr.hdr.cmd=BHMSG_SYSTEM_CONNECTION;
   hdr.hdr.sessionID=0;

   hdr.hdr.subcmd=BHMSG_SYSTEM_CONNECT;
   network->GetMac(c.mac);
   memcpy(hdr.data, &c, sizeof(BhPosConnect));		
   hdr.hdr.size=sizeof(BhPosConnect);
		
   hdr.hdr.Ex=0;
   hdr.hdr.flags=0;

   network->Send(&hdr, false, false, 0);*/
   return 0;
}

void CMfPosEngine::CustomerLookup(BhCustomerLookup *cs)
{
   BhPosHdr				hdr;
   
   memset(&hdr, 0, sizeof(hdr));
   memcpy(hdr.data, cs, sizeof(cs));
   /*
	BhCustomerLookup *cs=(BhCustomerLookup *) hdr.data;
   */
	hdr.hdr.type=BHPOS_TYPE_POST;
   hdr.hdr.cmd=BHMSG_POST_CUSTOMER;
   hdr.hdr.subcmd=BHMSG_POST_CUSTOMER_LIST;
   hdr.hdr.Ex=0;
   /*
	cs->customerID=0;
	
   strcpy(cs->lname, lname);
   strcpy(cs->phone, phone);
	strcpy(cs->fname, fname);*/
   hdr.hdr.size=sizeof(BhCustomerLookup);

   status=MF_STATUS_CUSTLOOKUP;
   Post(&hdr, false);
}

void CMfPosEngine::DeliveryList(int delID)
{
   BhPosHdr				hdr;
   
   memset(&hdr, 0, sizeof(hdr));

	hdr.hdr.type=BHPOS_TYPE_POST;
   hdr.hdr.cmd=BHMSG_POST_DELIVERY;
   hdr.hdr.subcmd=BHMSG_POST_DELIVERY_LIST;
   hdr.hdr.Ex=0;
   hdr.hdr.size=sizeof(int);
   memcpy(hdr.data, &delID, sizeof(int));
   
   status=MF_STATUS_DELIVERYLIST;
   Post(&hdr, false);
}

void CMfPosEngine::DeliveryReturn(int delID)
{
   BhPosHdr				hdr;
   
   memset(&hdr, 0, sizeof(hdr));
   
   hdr.hdr.type=BHPOS_TYPE_POST;
   hdr.hdr.cmd=BHMSG_POST_DELIVERY;
   hdr.hdr.subcmd=BHMSG_POST_DELIVERY_RETURNLIST;
   hdr.hdr.Ex=0;
   hdr.hdr.size=sizeof(int);
   memcpy(hdr.data, &delID, sizeof(int));
   
   status=MF_STATUS_DELIVERYRETLIST;
   Post(&hdr, false);
}

void CMfPosEngine::RentalList()
{
   BhPosHdr				hdr;
   
   memset(&hdr, 0, sizeof(hdr));
   
   hdr.hdr.type=BHPOS_TYPE_POST;
   hdr.hdr.cmd=BHMSG_POST_RENTAL;
   hdr.hdr.subcmd=BHMSG_POST_RENTAL_RETURN;
   hdr.hdr.Ex=0;
   hdr.hdr.size=0;
   
   status=MF_STATUS_RENTALLIST;
   Post(&hdr, false);
}

void CMfPosEngine::RentalLookup()
{
   BhPosHdr				hdr;
   
   memset(&hdr, 0, sizeof(hdr));
   
   hdr.hdr.type=BHPOS_TYPE_POST;
   hdr.hdr.cmd=BHMSG_POST_RENTAL;
   hdr.hdr.subcmd=BHMSG_POST_RENTAL_RETURN;
   hdr.hdr.Ex=0;
   hdr.hdr.size=0;
   
   status=MF_STATUS_RENTALLIST;
   Post(&hdr, false);
}

void CMfPosEngine::RentalReturnScan()
{
   BhPosHdr				hdr;
   
   memset(&hdr, 0, sizeof(hdr));
   
   hdr.hdr.type=BHPOS_TYPE_POST;
   hdr.hdr.cmd=BHMSG_POST_RENTAL;
   hdr.hdr.subcmd=BHMSG_POST_RENTAL_RETURN;
   hdr.hdr.Ex=0;
   hdr.hdr.size=0;
   
   status=MF_STATUS_RENTALLIST;
   Post(&hdr, false);
}

/*
void CMfPosEngine::SigpadSign(int type, bool bSign)
{
   if(bSign){   // prep the sigpad
      switch(type){
      case SIGPAD_SIGNTYPE_PRIVACY:
      case SIGPAD_SIGNTYPE_RX:
      case SIGPAD_SIGNTYPE_SAFETYCAPS:
      case SIGPAD_SIGNTYPE_COUNSELING:
      case SIGPAD_SIGNTYPE_CREDIT:
      case SIGPAD_SIGNTYPE_DEBIT:
         break;
      }
   }
   else{   // cancel the signature
   }
}
*/
void CMfPosEngine::CustomerAdd(BhCustomerItem *ci)
{
   BhPosHdr		   hdr;
   
   memset(&hdr, 0, sizeof(hdr));
   
   hdr.hdr.type=BHPOS_TYPE_POST;
   hdr.hdr.cmd=BHMSG_POST_CUSTOMER;
   hdr.hdr.subcmd=BHMSG_POST_CUSTOMER_NEW;
   hdr.hdr.Ex=0;
   hdr.hdr.size=sizeof(BhCashbackCheck);
   
   //status=MF_STATUS_CUSTNEW;
   Post(&hdr, false);
}

void CMfPosEngine::CustomerChargeBalance(BhCustomerCharBal *cb)
{
   BhPosHdr		   hdr;
   
   memset(&hdr, 0, sizeof(hdr));
   
   hdr.hdr.type=BHPOS_TYPE_POST;
   hdr.hdr.cmd=BHMSG_POST_CUSTOMER;
   hdr.hdr.subcmd=BHMSG_POST_CUSTOMER_CHARGEBAL;
   hdr.hdr.Ex=0;
   hdr.hdr.size=sizeof(BhCustomerCharBal);
   
   //status=MF_STATUS_CHARGEBAL;
   Post(&hdr, false);   
}

void CMfPosEngine::CustomerDropIn(BhCustomerItem *ci)
{
}

void CMfPosEngine::CustomerPickUp(BhCustomerItem *ci)
{
}

}
