/*
input.cpp
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
*/

#include "config.h"
#include <fcntl.h>
#include <gdk/gdkkeysyms.h>

//#include "pos.h"
//#include "ckeymap.h"
#include "cmfengine.h"

namespace bhmfengine {

///////////////////////////////////////////////////////////
//
// Mouse Events
//
//////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////
//
// Keyboard Events
//
//////////////////////////////////////////////////////////

int CMfPosEngine::KeySnooperEvent(Gtk::Widget *widget, GdkEventAny *event)
{
}

int CMfPosEngine::HandlesKeyEvent(GdkEventKey *ev)
{
   if(!bKeyRedirect){
      if(ev->keyval==ps2bcprefix){
         bKeyRedirect=true;
         return 1;
      }
      if(ev->keyval==GDK_F12 && 
        (ev->state & GDK_SHIFT_MASK) && 
        (ev->state & GDK_CONTROL_MASK)){
        bKeyRedirect=true;
        return 1;
      }
   }
   else{
      if(ev->keyval==ps2bcpostfix){
         bKeyRedirect=false;
         return 0;
      }
      if(ev->keyval==GDK_F12 && 
        (ev->state & GDK_SHIFT_MASK) && 
        (ev->state & GDK_CONTROL_MASK)){
        bKeyRedirect=false;
        return 0;   
      }
      KeyEvent(ev);
      return 1;
   }
   return 0;
}

int CMfPosEngine::KeyEvent(GdkEventKey *ev)
{
   static int  state=0;
   static Glib::ustring temp_buff;
   Glib::ustring other="";
   char        strprefix[3], mstest[256];
   int         type=0, err,buffpos;
   bool        bAlpha=false;
   bhpos::BarcodeDeviceType  dBcscanner;
   bhpos::MagSwipeDeviceType dMagswipe;
   BhMagswipe                ms;
   BhTransPayCredit          pc;
   
   config.GetOption(MFENG_CONFIG_BCSCANNER_DEVTYPE, &dBcscanner);
   config.GetOption(MFENG_CONFIG_MAGSWIPE_DEVTYPE, &dMagswipe);
   config.GetOption(MFENG_CONFIG_ALPHAPLU, &bAlpha);
   
   memset(&ms, 0, sizeof(ms));
   
#ifdef _DEBUGGERY   
   g_print("CMfPosEngine::KeyEvent bKeyDisabled: %d\nstate:%d\n status:%d\n adding %s:%d - buff:%s\n", bKeyDisabled, state, status, gdk_keyval_name(ev->keyval), ev->hardware_keycode, temp_buff.data());
#endif
   
   if(bKeyDisabled) return 1;
   
   if(bPostCompletion){
      bPostCompletion=false;
      return 1;
   }
   
   switch(status){
   case MF_STATUS_UNCONNECTED:
   case MF_STATUS_CONNECTING:
   case MF_STATUS_DISCONNECTING:
   case MF_STATUS_PRNSETUP:
   case MF_STATUS_PRNINIT:
   case MF_STATUS_PRNPREPRINT:
   case MF_STATUS_PRNHEADER:
   case MF_STATUS_PRNITEM:
   case MF_STATUS_PRNTRANSSUM:
   case MF_STATUS_PRNPAYSUM:
   case MF_STATUS_PRNFOOTER:
   case MF_STATUS_PRNPOSTPRINT:
   case MF_STATUS_JRNPREPRINT:
   case MF_STATUS_JRNITEM:
   case MF_STATUS_JRNPOSTPRINT:
   case MF_STATUS_LBLPREPRINT:
   case MF_STATUS_LBLITEM:
   case MF_STATUS_LBLPOSTPRINT:
   case MF_STATUS_CHKPREPRINT:
   case MF_STATUS_CHKITEM:
   case MF_STATUS_CHKPOSTPRINT:
   case MF_STATUS_SLIPPREPRINT:
   case MF_STATUS_SLIPHEADER:
   case MF_STATUS_SLIPITEM:
   case MF_STATUS_SLIPFOOTER:
   case MF_STATUS_SLIPPOSTPRINT:
   case MF_STATUS_ENDPREPRINT:
   case MF_STATUS_ENDITEM:
   case MF_STATUS_ENDPOSTPRINT:
   case MF_STATUS_MICRPREREAD:
   case MF_STATUS_MICRREAD:
   case MF_STATUS_MICRSTATUS:
   case MF_STATUS_MICRPOSTREAD:
   case MF_STATUS_CUSTDPRESALE:
   case MF_STATUS_CUSTDPOSTSALE:
   case MF_STATUS_CUSTDIDLE:
   case MF_STATUS_TAXLIST:
   case MF_STATUS_PRICELIST:
   case MF_STATUS_PREFIXLIST:
   case MF_STATUS_PAYLIST:
   case MF_STATUS_MENUHEADINGS:
   case MF_STATUS_MENUITEMS:
   case MF_STATUS_TRANSID:
   case MF_STATUS_TRANSIDONLY:
   case MF_STATUS_SCANNED:
   case MF_STATUS_PLULOOKUP:
   case MF_STATUS_LOGGOUTACK:
   case MF_STATUS_TRANSAUTH:
   case MF_STATUS_PAYAUTH:
   case MF_STATUS_CUSTLOOKUP:
   case MF_STATUS_PRINTING:
   case MF_STATUS_CDOPEN:
   case MF_STATUS_VOIDACK:
   case MF_STATUS_RETURNPLUCOMMIT:
   case MF_STATUS_RENTALPLUCOMMIT:
   case MF_STATUS_LAYBYPLUCOMMIT:
   case MF_STATUS_PRICECOMMIT:
   case MF_STATUS_CHEQUELOADWAIT:
   case MF_STATUS_CHEQUEPRNWAIT:
   case MF_STATUS_CHEQUEREMOVEWAIT:
      return 1;
   case MF_STATUS_LOGGEDOUT:
      break;
   case MF_STATUS_PASSIVELOGOUT:
      break;
   case MF_STATUS_USERLOOKUP:
   case MF_STATUS_LOGGEDIN:
   case MF_STATUS_IDLE:
   case MF_STATUS_PLUWAIT:
   case MF_STATUS_PLU:
   case MF_STATUS_PLUSCAN:
   case MF_STATUS_LISTEDIT:
   case MF_STATUS_PLULOOKUPNA:
   case MF_STATUS_SCANREMOVE:
   case MF_STATUS_TENDER:
   case MF_STATUS_PAYTYPE:
   case MF_STATUS_PAYAMOUNT:
      break;
   
   case MF_STATUS_TRANS:
   case MF_STATUS_UNKNOWNPLU:
   case MF_STATUS_ACK:
   case MF_STATUS_MAGWAIT:
   case MF_STATUS_MICRWAIT:
   case MF_STATUS_TRANSCOMMIT:
   case MF_STATUS_PLUCOMMIT:
   case MF_STATUS_UPLUCOMMIT:
   case MF_STATUS_PAYCOMMIT:
   case MF_STATUS_TRANSEND:
   case MF_STATUS_CASHADJUST:
   case MF_STATUS_TRANSRETRIEVE:
   case MF_STATUS_PLURETRIEVE:
   case MF_STATUS_UPLURETRIEVE:
   case MF_STATUS_PAYRETRIEVE:
   case MF_STATUS_TRANSRETEND:
   case MF_STATUS_TRANSRETEDIT:
   case MF_STATUS_CUSTENTRYOPEN:
      break;
   }
   
   // in case of fuckups, allow escape to reset buffer...
   if(status==MF_STATUS_PASSIVELOGOUT && ev->keyval==GDK_Escape && state!=0){
      state=0;
      temp_buff="";
      return 1;
   }
   //   special case of escape key
   if(ev->keyval==GDK_Escape){
      if(status==MF_STATUS_MICRWAIT){
         // cancel read with real time request
         //Print(BhPos::PRNCMD_MICR_CANCEL, NULL, 0);
         //status=0;
         return 1;
      }
	   //else if(status==MF_STATUS_CHPRNWAIT){
	      // cancel printing - simply eject it
	   //}
      else if(status==MF_STATUS_PASSIVELOGOUT){
         return 0;
      }
      else if(status==MF_STATUS_LOGGEDOUT){
         return 0;
      }
   }
   
   //if(ev->keyval==GDK_Return && status==MF_STATUS_PLUWAIT){
   //   return 1;
   //}
      
   
   // this can only happen in passive mode...
   if(status==MF_STATUS_PASSIVELOGOUT && ev->keyval!=GDK_dollar && ev->keyval!=GDK_exclam && state!=1){
      switch(ev->keyval){
      case GDK_F4: return 0;
      case GDK_0:
      case GDK_1:
      case GDK_2:
      case GDK_3:
      case GDK_4:
      case GDK_5:
      case GDK_6:
      case GDK_7:
      case GDK_8:
      case GDK_9:
      case GDK_KP_0:
      case GDK_KP_1:
      case GDK_KP_2:
      case GDK_KP_3:
      case GDK_KP_4:
      case GDK_KP_5:
      case GDK_KP_6:
      case GDK_KP_7:
      case GDK_KP_8:
      case GDK_KP_9:
      case GDK_Linefeed:
      case GDK_Return:
      case GDK_KP_Enter:
         break;
      default: 
         return 1;
      }
      if(state==0){
         state=64;
         temp_buff="";
         //temp_buff+=gdk_keyval_name(ev->keyval);
      }
      else if(state==64){
         if(ev->keyval==GDK_Return || ev->keyval==GDK_Linefeed || ev->keyval==GDK_KP_Enter){   // post it off
            BhLogonRequestEx lor;
            memset(&lor, 0, sizeof(lor));
            lor.postID=0;
            lor.type=BHPOS_LOGIN_TYPES_PASSIVE;
            strcpy(lor.data.raw, temp_buff.data());
            Login(&lor);
            state=0;   
            temp_buff="";
            //status=MF_STATUS_USERLOOKUP;
            //bKeyDisabled=true;
            system_signal.emit(BHMF_EVENT_USERLOOKUP, NULL);
            return 2;
         }
         temp_buff+=gdk_keyval_name(ev->keyval);
         return 1;
      }
   }

   if(state==32 && dBcscanner==bhpos::BCDEV_TYPE_KEYBOARD){
      switch(ev->keyval){
      case GDK_0:
      case GDK_1:
      case GDK_2:
      case GDK_3:
      case GDK_4:
      case GDK_5:
      case GDK_6:
      case GDK_7:
      case GDK_8:
      case GDK_9:
      case GDK_KP_0:
      case GDK_KP_1:
      case GDK_KP_2:
      case GDK_KP_3:
      case GDK_KP_4:
      case GDK_KP_5:
      case GDK_KP_6:
      case GDK_KP_7:
      case GDK_KP_8:
      case GDK_KP_9:
         break;
      case GDK_Linefeed:
      case GDK_Return:
      case GDK_KP_Enter:
         if(status==MF_STATUS_PASSIVELOGOUT){   // barcode complete - post it
            BhLogonRequestEx lor;
            memset(&lor, 0, sizeof(lor));
            lor.postID=0;
            lor.type=BHPOS_LOGIN_TYPES_BARCODE;
            strcpy(lor.data.raw, temp_buff.data());
            //status=MF_STATUS_USERLOOKUP;
            //bKeyDisabled=true;
            pos_signal.emit(BHMF_EVENT_USERLOOKUP, NULL);
            Login(&lor);
            state=0;   
            temp_buff="";
            return 1;
         }
         if(status==MF_STATUS_CUSTLOOKUP){
            pos_signal.emit(BHMF_EVENT_CUSTLOOKUP_SCAN, NULL);
            state=0;
            temp_buff="";
            return 1;
         }
         if(status==MF_STATUS_RENTALLOOKUP){
            pos_signal.emit(BHMF_EVENT_RENTALLOOKUP_SCAN, NULL);
            state=0;   
            temp_buff="";
            return 1;
         }
         if(status==MF_STATUS_RENTALRETURN){
            pos_signal.emit(BHMF_EVENT_RENTALRETURN_SCAN, NULL);
            state=0;   
            temp_buff="";
            return 1;
         }
         if(status==MF_STATUS_DELIVERYRETURN){
            pos_signal.emit(BHMF_EVENT_DELIVERYRETURNLOOKUP_SCAN, NULL);
            state=0;   
            temp_buff="";
            return 1;
         }
         if(status==MF_STATUS_CUSTITEMPICKUP){
            pos_signal.emit(BHMF_EVENT_CUSTITEMPICKUP_SCAN, NULL);
            state=0;   
            temp_buff="";
            return 1;
         }
         if(status==MF_STATUS_SCANREMOVE){
            int newqty;
            bhpos::CSaleItem si;
            si.SetPLU(temp_buff);
            if(!transstack.Decrement(current_transaction, si, &newqty)){
               // item not found
               status=MF_STATUS_IDLE;
               temp_buff="";
               state=0;
               return 1;
            }
            
            si.SetQuantity(newqty);
            if(newqty==0){
               transaction_signal.emit(BHMF_EVENT_SITEM_REMOVE, (void *) &si);
            }
            else{
               transaction_signal.emit(BHMF_EVENT_SITEM_EDIT, (void *) &si);
            }
         }
         else{
            transaction_signal.emit(BHMF_EVENT_SITEM_PLUSCAN, (void *) &temp_buff);
         }
         temp_buff="";
         state=0;
         return 1;
      default: 
         if(bAlpha){
            if(IsAlpha(ev)) break;
         }
         return 1;
      }
      temp_buff+=gdk_keyval_name(ev->keyval);
      return 1;
   }
   if(ev->keyval==GDK_dollar && dBcscanner==bhpos::BCDEV_TYPE_KEYBOARD && state==0){
      state=32;
      temp_buff="";
      return 1;
   }

   
   /* Ok, now we have the gated barcode scanner, and the magswipe stuff
    *
    * These reply on setting up the keyboard start/end sentinels to:
    *
    * followed by:
    *  comma:      bc 1 event
    *  minus:      bc 2 event
    *  percent:    magswipe track 1 event
    *  ampersand:  magswipe track 2 event
    *  apostrophe: magswipe track 3 event
    *  plus:       magswipe track 4 event
    *  period:     smartcard 1 event
    *  slash:      smartcard 2 event
    *
    */
   if(ev->keyval==GDK_exclam){ // we have a sentinel
      //g_print("magswipe event\n");
      if(state==0){
         state=1;
         temp_buff="";
      }
      return 1;
   }
   if(state > 1){
      if(ev->keyval==GDK_Linefeed || ev->keyval==GDK_Return || ev->keyval==GDK_KP_Enter){
         switch(state){
         case 2:  // bc 1 done
            if(status==MF_STATUS_PASSIVELOGOUT || status==MF_STATUS_LOGGEDOUT){   // barcode complete - post it
               if(temp_buff.size()==13){
                  memset(strprefix, 0, sizeof(strprefix)); 
                  memcpy(strprefix, temp_buff.data(), 2);
                  strprefix[2]=0;
                  type=atoi(strprefix);
                  if(type==bc_prefix.interface_prefix){
#ifdef _DEBUGGERY          
                     printf("request for interface barcode\n");
#endif   
                     BhLogonRequestEx lor;
                     memset(&lor, 0, sizeof(lor));
                     lor.postID=0;
                     lor.type=BHPOS_LOGIN_TYPES_PASSIVE;
                     strcpy(lor.data.raw, temp_buff.data());
                     system_signal.emit(BHMF_EVENT_USERLOOKUP, NULL);
                     Login(&lor);
                     state=0;   
                     temp_buff="";
                     return 1;
                  }
                  else{
                     state=0;   
                     temp_buff="";
                  }
               }
               return 1;
            }
            else if(status==MF_STATUS_CUSTENTRYOPEN){ // attempt customer barcode lookup
               if(temp_buff.size()==13){
                  memset(strprefix, 0, sizeof(strprefix)); 
                  memcpy(strprefix, temp_buff.data(), 2);
                  strprefix[2]=0;
                  type=atoi(strprefix);
                  if(type==bc_prefix.customer_prefix){
#ifdef _DEBUGGERY          
                     printf("request for customer barcode\n");
#endif
                     BhLogonRequestEx lor;
                     memset(&lor, 0, sizeof(lor));
                     lor.postID=0;
                     lor.type=BHPOS_LOGIN_TYPES_BARCODE;
                     strcpy(lor.data.raw, temp_buff.data());
                     CustomerEvent(BHMF_CUSTOMER_BARCODE, &lor);
                     state=0;   
                     temp_buff="";
                     return 1;
                  }
                  else{
                     // a no go
                     temp_buff="";
                  }
               }
               return 1;
            }
            else if(mode==MF_MODE_SALE){ 
               if(temp_buff.size()==13){
                  memset(strprefix, 0, sizeof(strprefix)); 
                  memcpy(strprefix, temp_buff.data(), 2);
                  strprefix[2]=0;
                  type=atoi(strprefix);
                  if(type==bc_prefix.customer_prefix){
#ifdef _DEBUGGERY          
                     printf("request for customer barcode\n");
#endif
                     BhLogonRequestEx lor;
                     memset(&lor, 0, sizeof(lor));
                     lor.postID=0;
                     lor.type=BHPOS_LOGIN_TYPES_BARCODE;
                     strcpy(lor.data.raw, temp_buff.data());
                     CustomerEvent(BHMF_CUSTOMER_BARCODE, &lor);
                     state=0;   
                     temp_buff="";
                     return 1;
                  }
                  else{
                     // a no go
                     temp_buff="";
                  }
               }
               return 1;
            }
            // it's a barcode scan
            {
            system_signal.emit(BHMF_CMD_SITEM_SCAN, &temp_buff);
            bhpos::CSaleItem si(temp_buff);
            SaleItemAdd(si, true);
            state=0;
            temp_buff="";
            }
            break;
            
         case 3:  // bc 2 done
            state=0;
            temp_buff="";
            // simulate return key for PLU entry in Ctransaction
            //memcpy(&turp, ev, sizeof(ev));
            //turp.keyval=GDK_Return;
            //turp.state=0;
            //trans->KeyPress(&turp);
            break;
         
         case 4:  // magswipe track 1 done
            //g_print("ms 1\n");
            strcpy(mstest, temp_buff.data());
            if(mstest[0]=='^'){ // real credit card
               //g_print("ms 1 real...\n");
               if((err=SwipeParse(bhpos::MAGSWIPE_TRACK_1, temp_buff.data(), &ms))){
                  hwerror_signal.emit(ERR_HW_MAGSWIPE_TRACK1_READ, &err);
#ifdef _DEBUGGERY          
                  g_print("magswipe track 1 fail: %d\n", err);
#endif
                  state=0;
                  temp_buff="";
                  return 1;
               }
            }
            else if(status==MF_STATUS_LOGGEDOUT || status==MF_STATUS_PASSIVELOGOUT){   // not a real credit card... attempt magswipe login
               //g_print("magswipe login: %s\n", temp_buff.data());
               BhLogonRequestEx lor;
               memset(&lor, 0, sizeof(lor));
               lor.postID=0;
               lor.type=BHPOS_LOGIN_TYPES_MAGSWIPE;
               strcpy(lor.data.raw, temp_buff.data());
               //status=MF_STATUS_USERLOOKUP;
               //bKeyDisabled=true;
               pos_signal.emit(BHMF_EVENT_USERLOOKUP, NULL);
               Login(&lor);
               state=0;   
               temp_buff="";
               return 1;
            }
            else if(status==MF_STATUS_CUSTENTRYOPEN){ // attempt customer lookup
               return 1;
            }
            else if(status==MF_STATUS_MAGWAIT){ // in-house charge
            }
            
            if(mode==MF_MODE_SALE){ // possible loyality store card
               /*
               strcpy(pc.track1, temp_buff);
               buffpos=strlen(pc.track1);
               if(pc.track1[buffpos - 1]!='?'){
                  pc.track1[buffpos]='?';
                  pc.track1[buffpos + 1]=0;
               }*/
               return 1;
            }
            
            break;
            
         case 5:  // magswipe track 2 done
            if((err=SwipeParse(bhpos::MAGSWIPE_TRACK_2, temp_buff.data(), &ms))){
               hwerror_signal.emit(ERR_HW_MAGSWIPE_TRACK2_READ, &err);
#ifdef _DEBUGGERY          
               g_print("magswipe track 1 fail: %d\n", err);
#endif
               state=0;
               temp_buff="";
               return 1;
            }
            
            if(temp_buff.length() > 40) temp_buff.resize(40); // bigger buggerfish
            strcpy(pc.track2, temp_buff.data());
            buffpos=strlen(pc.track2);
            if(pc.track2[buffpos - 1]!='?'){
               pc.track2[buffpos]='?';
               pc.track2[buffpos + 1]=0;
            }
            state=0;
            buffpos=0;
            
            if(status==MF_STATUS_MAGWAIT){
               BhPosHdr          hdr;
                                           
               pc.pa.transID=current_transaction;
               pc.pa.type=CurrPayAuth.GetID();
               pc.pa.amount=CurrPayAuth.GetAmount();

               status=MF_STATUS_PAYAUTH;
 
               hdr.hdr.type=BHPOS_TYPE_POST;
               hdr.hdr.cmd=BHMSG_POST_TRANSACTION;
               hdr.hdr.subcmd=BHMSG_POST_TRANSACTION_PAYAUTH;
               hdr.hdr.Ex=0;
               hdr.hdr.size=sizeof(BhTransPayCredit);
               memcpy(hdr.data, &pc, sizeof(BhTransPayCredit));
               pos_signal.emit(BHMF_EVENT_PITEM_AUTH, NULL);
               Post(&hdr, true);
            }
            /*
            else if(status==MF_STATUS_LOGGEDOUT){   // attempt magswipe login
               return 1;
            }
            else if(status==MF_STATUS_CUSTENTRYOPEN){ // attempt customer lookup
               return 1;
            }*/
             break;
             
         case 6:  // magswipe track 3 done
            // don't give a crap about thrift track...
            break;
         case 7:  // magswipe track 4 done
            // doesn't really exist
            break;
         case 8:  // smartcard 1 done
            break;
         case 9:  // smartcard 2 done
            break;
         }  
      }
      //return 1;
   }
   
   if(state==1){
      switch(ev->keyval){
      case GDK_comma:      // bc 1 event
         state=2;
         break;
      case GDK_minus:      // bc 2 event
         state=3;
         break;
      case GDK_percent:      // magswipe track 1 event
         //g_print("magswipe event track 1 start\n");
         //temp_buff='%';
         state=4;
         memset(pc.track1, '0', sizeof(pc.track1));
         break;
      case GDK_ampersand:   // magswipe track 2 event
         temp_buff=';';
         state=5;
         memset(pc.track2, '0', sizeof(pc.track2));
         break;
      case GDK_apostrophe: // magswipe track 3 event
         state=6;
         break;
      case GDK_plus:       // magswipe track 4 event
         state=7;
         break;
      case GDK_period:        
         state=8;          // smartcard 1 event
         break;
      case GDK_slash:
         state=9;          // smartcard 2 event
         break;
      }
      return 1;
   }

   if(state==2 || state==3){
      return 1;
   }
   if(state > 1){
      // this is to fix some weird crap with cherry keyboards:
      // every other char is a left shift (0xFFE1) on magswipe scans
      if(ev->keyval < 0xFF && ev->keyval > 0x19){
         if(ev->keyval==GDK_space) return 1;
         temp_buff+=gdk_keyval_name(ev->keyval);
      }
      return 1;
   }
   if(!KeyInState(ev)){
      //g_print("key not enabled\n");
      return 1;
   }
   return 0;
}

bool CMfPosEngine::KeyInState(GdkEventKey *e)
{
   bool bAlpha=false;
   
   config.GetOption(MFENG_CONFIG_ALPHAPLU, &bAlpha);
   
   switch(status){
   case MF_STATUS_LOGGEDIN:
      if(IsNumber(e)) return true;
      if(bAlpha){
         if(IsAlpha(e)) return true;
      }
      switch(e->keyval){
      case GDK_equal:
      case GDK_KP_Equal:
	   case GDK_KP_Add:
      case GDK_plus:
      case GDK_Escape:
      case GDK_KP_Enter:
      case GDK_Return:
      case GDK_F2: // sale type
      case GDK_F3: // pay out
      case GDK_F4: // trans cycle
      case GDK_F5: // cash item
         return true;
      default:
         return false;
      }
      break;
      
   case MF_STATUS_IDLE:
      if(IsNumber(e)) return true;
      if(bAlpha){
         if(IsAlpha(e)) return true;
      }
      switch(e->keyval){
      case GDK_equal:
      case GDK_KP_Equal:
	   case GDK_KP_Add:
      case GDK_plus:
	   case GDK_KP_Subtract:		
   	case GDK_minus:
      case GDK_KP_Home:
      case GDK_Home:
	   case GDK_KP_Up:
      case GDK_Up:
	   case GDK_KP_Left:
      case GDK_Left:
	   case GDK_KP_Right:
   	case GDK_Right:
      case GDK_KP_Down:
   	case GDK_Down:
      case GDK_KP_Page_Up:
   	case GDK_Page_Up:
      case GDK_KP_Page_Down:
   	case GDK_Page_Down:
      case GDK_KP_End:
   	case GDK_End:
      case GDK_Escape:
      case GDK_KP_Enter:
      case GDK_Return:;
      case GDK_F2: // sale type
      case GDK_F3: // pay out
      case GDK_F4: // trans cycle
      case GDK_F5: // cash item
      case GDK_F11: // plu lookup
      case GDK_F12: // remove by scan
         return true;
      default:
         return false;
      }
      break;
      
   case MF_STATUS_PLUWAIT:
      if(IsNumber(e)) return true;
      switch(e->keyval){
      case GDK_equal:
      case GDK_KP_Equal:
	   case GDK_KP_Add:
      case GDK_plus:
	   case GDK_KP_Subtract:		
   	case GDK_minus:
      case GDK_Escape:
      case GDK_KP_Enter:
      //case GDK_Return:
      case GDK_Right:
         return true;
      default:
         return false;
      }
      break;
      
   case MF_STATUS_QUANTITY:
      if(IsNumber(e)) return true;
      switch(e->keyval){
      case GDK_Escape:
      case GDK_KP_Enter:
      case GDK_Return:
      case GDK_equal:
      case GDK_KP_Equal:
      case GDK_KP_Add:
      case GDK_plus:
	   case GDK_KP_Subtract:		
   	case GDK_minus:
         return true;
      default:
         return false;
      }
      break;
      
   case MF_STATUS_PLULOOKUP:
      switch(e->keyval){
      case GDK_Escape:
         return true;
      }
      break;
      
   case MF_STATUS_DESCRIPTIONENTRY:
      switch(e->keyval){
      case GDK_Escape:
      case GDK_Return:
      case GDK_space:
         return true;
      }
      break;
      
   case MF_STATUS_PRICEENTRY:
      switch(e->keyval){
      case GDK_Escape:
      case GDK_Return: 
         return true;
      }
      break;
      
   case MF_STATUS_SCANREMOVE:
      switch(e->keyval){
      case GDK_Escape:
         return true;
      }
      break;
   
   case MF_STATUS_LISTEDIT:
      switch(e->keyval){
      case GDK_equal:
      case GDK_KP_Equal:
	   case GDK_KP_Add:
      case GDK_plus:
	   case GDK_KP_Subtract:		
   	case GDK_minus:
      case GDK_KP_Home:
      case GDK_Home:
	   case GDK_KP_Up:
      case GDK_Up:
	   case GDK_KP_Left:
      case GDK_Left:
	   case GDK_KP_Right:
   	case GDK_Right:
      case GDK_KP_Down:
   	case GDK_Down:
      case GDK_KP_Page_Up:
   	case GDK_Page_Up:
      case GDK_KP_Page_Down:
   	case GDK_Page_Down:
      case GDK_KP_End:
   	case GDK_End:
      case GDK_Escape:
      case GDK_KP_Enter:
      case GDK_Return:
      case GDK_Delete:
         return true;
      default:
         return false;
      }
      break;
   
   case MF_STATUS_TENDER:
      switch(e->keyval){
      case GDK_Escape:
      case GDK_F5: // cash
      case GDK_F6: // credit
      case GDK_F7: // cheque
      case GDK_F8:
         return true;
      default:
         return false;
      }
      break;
      
   case MF_STATUS_PAYTYPE:
      if(IsNumber(e)) return true;
      switch(e->keyval){
      case GDK_Escape:
      case GDK_KP_Enter:
      case GDK_Return:
         return true;
      default:
         return false;
      }
      break;
      
   case MF_STATUS_PAYAMOUNT:
      if(IsNumber(e)) return true;
      switch(e->keyval){
      case GDK_Escape:
      case GDK_KP_Enter:
      case GDK_Return:
      //case GDK_period:
         return true;
      default:
         return false;
      }
      break;
   
   case MF_STATUS_PAYEDIT:
      switch(e->keyval){
      case GDK_equal:
      case GDK_KP_Equal:
      case GDK_KP_Home:
      case GDK_Home:
	   case GDK_KP_Up:
      case GDK_Up:
	   case GDK_KP_Left:
      case GDK_Left:
	   case GDK_KP_Right:
   	case GDK_Right:
      case GDK_KP_Down:
   	case GDK_Down:
      case GDK_KP_Page_Up:
   	case GDK_Page_Up:
      case GDK_KP_Page_Down:
   	case GDK_Page_Down:
      case GDK_KP_End:
   	case GDK_End:
      case GDK_Escape:
      case GDK_KP_Enter:
      case GDK_Return:
      case GDK_Delete:
         return true;
      default:
         return false;
      }
      break;
      
   case MF_STATUS_CONFIRMCOMMIT:
      switch(e->keyval){
      case GDK_Escape:
      case GDK_KP_Enter:
      case GDK_Return:
         return true;
      default:
         return false;
      }
      break;
      
   case MF_STATUS_TRANSCOMMIT:
   case MF_STATUS_PLUCOMMIT:
   case MF_STATUS_RETURNPLUCOMMIT:
   case MF_STATUS_RENTALPLUCOMMIT:
   case MF_STATUS_LAYBYPLUCOMMIT:
   case MF_STATUS_PRICECOMMIT:
   case MF_STATUS_UPLUCOMMIT:
   case MF_STATUS_PAYCOMMIT:
   case MF_STATUS_TRANSEND:
      switch(e->keyval){
      case GDK_Escape:
         return true;
      default:
         return false;
      }
      break;   
   
   case MF_STATUS_PASSIVELOGOUT:
      if(e->keyval==GDK_F4) return true;
      break;
   }
   return false;
}

bool CMfPosEngine::IsNumber(GdkEventKey *e)
{
   switch(e->keyval){
   case GDK_0:
   case GDK_1:
   case GDK_2:
   case GDK_3:
   case GDK_4:
   case GDK_5:
   case GDK_6:
   case GDK_7:
   case GDK_8:
   case GDK_9:
   case GDK_KP_0:
   case GDK_KP_1:
   case GDK_KP_2:
   case GDK_KP_3:
   case GDK_KP_4:
   case GDK_KP_5:
   case GDK_KP_6:
   case GDK_KP_7:
   case GDK_KP_8:
   case GDK_KP_9:
      return true;
   }
   return false;
}

bool CMfPosEngine::IsAlpha(GdkEventKey *e)
{
   switch(e->keyval){
   case GDK_a:
   case GDK_b:
   case GDK_c:
   case GDK_d:
   case GDK_e:
   case GDK_f:
   case GDK_g:
   case GDK_h:
   case GDK_i:
   case GDK_j:
   case GDK_k:
   case GDK_l:
   case GDK_m:
   case GDK_n:
   case GDK_o:
   case GDK_p:
   case GDK_q:
   case GDK_r:
   case GDK_s:
   case GDK_t:
   case GDK_u:
   case GDK_v:
   case GDK_w:
   case GDK_x:
   case GDK_y:
   case GDK_z:
   case GDK_A:
   case GDK_B:
   case GDK_C:
   case GDK_D:
   case GDK_E:
   case GDK_F:
   case GDK_G:
   case GDK_H:
   case GDK_I:
   case GDK_J:
   case GDK_K:
   case GDK_L:
   case GDK_M:
   case GDK_N:
   case GDK_O:
   case GDK_P:
   case GDK_Q:
   case GDK_R:
   case GDK_S:
   case GDK_T:
   case GDK_U:
   case GDK_V:
   case GDK_W:
   case GDK_X:
   case GDK_Y:
   case GDK_Z:
      return true;
   }
   return false;
}

bool CMfPosEngine::IsMonetary(GdkEventKey *e)
{
   /*
   char * nl_langinfo(nl_item item)
   MON_DECIMAL_POINT
   MON_THOUSANDS_SEP
   DECIMAL_POINT
   THOUSANDS_SEP
   MON_GROUPING   
   char *decimal_point
   char *mon_decimal_point   
   char *thousands_sep
   char *mon_thousands_sep
   char *grouping
   char *mon_grouping 
   */
}

bool CMfPosEngine::BarcodeType(Glib::ustring barcode)
{
   /* GlobalPrefix - bc_prefix:
   int weight_prefix;
   int quantity_prefix;
   int price_prefix;
   int interface_prefix;
   int token_prefix;
   int voucher_prefix;
   int customer_prefix;
   int instore_prefix;
   */
}

/*********************************************************************************
 *
 * Track 1: 76 alphanumeric data chars
 * <ss><fc> Pan <fs> Name <fs> Additional data | discretionary data <es> <LCR>
 *
 * Track 2: 37 alphanumeric data chars
 * <ss> Pan <fs> Additional data | discretionary data <es> <LCR>
 *
 *
 * PAN  - primary account number - 19 digits max
 * Name - 26 alphanumeric characters max
 * additional data:
 *   expiration date (YYMM) 4 characters
 *   service code 3 characters
 *
 * discretionary data:
 *   PVKI       1 char  (PIN Verification Key Indicator)
 *   PVV        4 chars (PIN Verification Value)
 *   CVV or CVC 3 chars (Card Verification Value/Code)
 *
 *
 * Track 3: 104 alphanumeric data chars
 * <ss><fc> Pan <fs> use and security data | Additional data <es> <LCR>
 *
 *********************************************************************************/

int CMfPosEngine::SwipeParse(bhpos::MagSwipeTrack t, const char *data, BhMagswipe *ms)
{
   int   n=0, state=0;
   const char *x=data;
   char  buff[128];
   
   if(data==NULL) return 2;
   
   memset(buff, 0, sizeof(buff));
   
   unsigned char lcr;
      
	if(t==bhpos::MAGSWIPE_TRACK_1){
      if(strlen(data) > 79) return 3;
      if(*x!='%') return 4;
      lcr=*x;
      strncpy(ms->track1.raw, data, 79);
      strncpy(ms->track1.track1_details.formatcode, x, 1);
      x++;
      while(x){
         if(*x=='^'){   // fs
            if(state==0){  //pan
               if(strlen(buff) > 19) return 4;
               strcpy(ms->track1.track1_details.pan, buff);
               memset(buff, 0, sizeof(buff));
               n=0;
               state=1;
               x++;
               continue;
            }
            else if(state==1){   // name
               if(strlen(buff) > 26) return 4;
               strcpy(ms->track1.track1_details.name, buff);
               memset(buff, 0, sizeof(buff));
               n=0;
               state=2;
               x++;
               continue;
            }
         }
         if(n==3 && state==2){   // exp date
            strcpy(ms->track1.track1_details.expdate, buff);
            memset(buff, 0, sizeof(buff));
            n=0;
            state=3;
            x++;
            continue;
         }
         if(n==2 && state==3){   // service code
            strcpy(ms->track1.track1_details.servicecode, buff);
            memset(buff, 0, sizeof(buff));
            n=0;
            state=4;
            x++;
            continue;
         }
         if(n==1 && state==4){
            strcpy(ms->track1.track1_details.pvki, buff);
            memset(buff, 0, sizeof(buff));
            n=0;
            state=5;
            continue;
         }
         if(n==3 && state==5){
            strcpy(ms->track1.track1_details.pvv, buff);
            memset(buff, 0, sizeof(buff));
            n=0;
            state=6;
            x++;
            continue;
         }
         if(n==2 && state==6){
            strcpy(ms->track1.track1_details.ccv, buff);
            state=7;
            continue;
         }
         if(state==7){  // wait on end sentinel
            if(*x=='?') return 0;
         }
         //lcr^=x;
         buff[n]=*x;
         n++;
         x++;
      }         
      return 5;   // no end sentinel
   }
   else if(t==bhpos::MAGSWIPE_TRACK_2){
      if(strlen(data) > 40) return 3;
      if(*x!=';') return 4;
      lcr=*x;
      strncpy(ms->track1.raw, data, 79);
      strncpy(ms->track1.track1_details.formatcode, x, 1);
      x++;
      while(x){
         if(*x=='='){   // fs
            if(state==0){  //pan
               if(strlen(buff) > 19) return 4;
               strcpy(ms->track2.track2_details.pan, buff);
               memset(buff, 0, sizeof(buff));
               n=0;
               state=1;
               x++;
               continue;
            }
         }
         if(n==3 && state==1){   // exp date
            strcpy(ms->track2.track2_details.expdate, buff);
            memset(buff, 0, sizeof(buff));
            n=0;
            state=2;
            x++;
            continue;
         }
         if(n==2 && state==2){   // service code
            strcpy(ms->track2.track2_details.servicecode, buff);
            memset(buff, 0, sizeof(buff));
            n=0;
            state=3;
            x++;
            continue;
         }
         if(n==1 && state==3){
            strcpy(ms->track2.track2_details.pvki, buff);
            memset(buff, 0, sizeof(buff));
            n=0;
            state=4;
            continue;
         }
         if(n==3 && state==4){
            strcpy(ms->track2.track2_details.pvv, buff);
            memset(buff, 0, sizeof(buff));
            n=0;
            state=5;
            x++;
            continue;
         }
         if(n==2 && state==5){
            strcpy(ms->track2.track2_details.ccv, buff);
            state=6;
            continue;
         }
         if(state==6){  // wait on end sentinel
            if(*x=='?') return 0;
         }
         //lcr^=x;
         buff[n]=*x;
         n++;
         x++;
      }         
      return 5;   // no end sentinel
   }
   else if(t==bhpos::MAGSWIPE_TRACK_3){
      return 1;
   }
   return 1;
}

}
