/*
setup.cpp - a point of sale client class
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001-2004 Al Kingsley
*/

#include "config.h"
#include <fcntl.h>

#include "pos.h"
#include "bhnetwork.h"
#include "ctransitems.h"
#include "cmfengine.h"

namespace bhmfengine {

int CMfPosEngine::Login(BhLogonRequestEx *li)
{
   BhPosHdr       hdr;
   
   memset(&hdr, 0, sizeof(hdr));
	
   status=MF_STATUS_USERLOOKUP;
   
   hdr.hdr.type=BHPOS_TYPE_SYSTEM;
   hdr.hdr.cmd=BHMSG_SYSTEM_LOGIN;
   hdr.hdr.subcmd=BHMSG_SYSTEM_LOGIN_LOGINEXT;
   li->postID=connection_info.PostID;
   memcpy(hdr.data, li, sizeof(BhLogonRequestEx));
   hdr.hdr.size=sizeof(BhLogonRequestEx);
   
   Post(&hdr, false);
   return 0;
}

int CMfPosEngine::Logout()
{
   BhPosHdr	hdr;
	BhLogout	bhlout;
	
   memset(&hdr, 0, sizeof(hdr));
   memset(&bhlout, 0, sizeof(bhlout));
	bhlout.postID=connection_info.PostID;
	bhlout.userID=userID;
	
	hdr.hdr.type=BHPOS_TYPE_SYSTEM;
	hdr.hdr.cmd=BHMSG_SYSTEM_LOGIN;
	hdr.hdr.subcmd=BHMSG_SYSTEM_LOGIN_LOGOUT;
	hdr.hdr.size=sizeof(BhLogout);
	memcpy(hdr.data, &bhlout, sizeof(BhLogout));
   status=MF_STATUS_LOGGOUTACK;
   Post(&hdr, false);
   return 0;
}

void CMfPosEngine::Clockin(BhClockIn *clkin)
{
/*void CMfPosEngine::Clockin(bool bIn, int type, const char *data)
{
	BhPosHdr	  hdr;
	BhClockIn *clkin=(BhClockIn *) hdr.data;

	memset(&hdr, 0, sizeof(hdr));
   memcpy(&hdr.data, clkin, sizeof(clkin));
	
	hdr.hdr.type=BHPOS_TYPE_POST;
	hdr.hdr.cmd=BHMSG_POST_ATTENDANCE;
   if(bIn){
	   hdr.hdr.subcmd=BHMSG_POST_ATTENDANCE_CLOCKIN;
   }
   else{
      hdr.hdr.subcmd=BHMSG_POST_ATTENDANCE_CLOCKOUT;
   }
	hdr.hdr.size=sizeof(clkin);
	
	status=MF_STATUS_CLOCKINACK;
   Post(&hdr, false);*/
}

}
