/*
mfplugin.cpp
Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
*/
#include <cstdio>
#include <dlfcn.h>

#include "cmfplugin.h"

#define _DEBUGGERY
int	DebugMode=4;

static void *bollocks;

namespace bhmfengine{

namespace plugin{

CMfPlugIn::CMfPlugIn()
{
	fname="";
	mod_handle=NULL;
	mfeng=NULL;
   //mod_h=0;
	
	Initialize=NULL;
	CleanUp=NULL;
	GetNumMsgHandlers=NULL;
	Handler=NULL;
	Lock=NULL;
	Release=NULL;
}

CMfPlugIn::CMfPlugIn(CMfPlugIn const& mh)
{
   fname=mh.fname;
	mfeng=mh.mfeng;
   MsgTypes=mh.MsgTypes;
   mod_handle=mh.mod_handle;
	
   /*
	Initialize=mh.Initialize;
	CleanUp=mh.CleanUp;
	GetNumMsgHandlers=mh.GetNumMsgHandlers;
	Handler=mh.Handler;
	Lock=mh.Lock;
	Release=mh.Release;*/
}

CMfPlugIn::CMfPlugIn(CMfPosEngine *m, Glib::ustring name, void *arg)
{
	fname=fname;
	mfeng=m;
	
	mod_handle=NULL;
	
	Initialize=NULL;
	CleanUp=NULL;
	GetNumMsgHandlers=NULL;
	Handler=NULL;
	Lock=NULL;
	Release=NULL;
	
	Load(m, name, arg);
}
CMfPlugIn::~CMfPlugIn()
{
	Close();
}

void CMfPlugIn::operator=(CMfPlugIn const& mh)
{
	fname=mh.fname;
	mod_handle=mh.mod_handle;
	mfeng=mh.mfeng;
   MsgTypes=mh.MsgTypes;
	
   /*
	Initialize=mh.Initialize;
	CleanUp=mh.CleanUp;
	GetNumMsgHandlers=mh.GetNumMsgHandlers;
	Handler=mh.Handler;
	Lock=mh.Lock;
	Release=mh.Release;*/
}

bool CMfPlugIn::operator==(CMfPlugIn const& mh)
{
   if(mod_handle==mh.mod_handle) return true;
	return false;
}

bool CMfPlugIn::operator<(CMfPlugIn const& mh)
{
	return false;
}


void CMfPlugIn::Close()
{
	if(!MsgTypes.empty()) MsgTypes.clear();
	if(mod_handle) dlclose(mod_handle);
}


int CMfPlugIn::Load(CMfPosEngine *m, Glib::ustring name, void *arg)
{
   int status;
	fname=name;
   
	mfeng=m;
	
	const	char	*errmsg;
	
	mod_handle=dlopen(name.data(), RTLD_NOW | RTLD_GLOBAL);
	if(mod_handle==NULL){
		if(DebugMode > 2){
			printf("Can't load module: %s - %s\n", name.data(), dlerror());
		}
		return 1;
	}
   //mod_handle=(unsigned int) *((unsigned int *) mod_handle);
	dlerror();
	// try for standard module functions...
   Initialize = (Initialize_t) dlsym(mod_handle, "Initialize");
	if((errmsg=dlerror())!=NULL){
		if(DebugMode > 2){
			printf("Can't find Initialize in module %s - %s\n", name.data(), errmsg);
		}
		Close();
		return 2;
	}
   //i_func=(unsigned int) *((unsigned int *) Initialize);
   
	CleanUp = (CleanUp_t) dlsym(mod_handle, "CleanUp");
	if((errmsg=dlerror())!=NULL){
		if(DebugMode > 2){
			printf("Can't find CleanUp in module %s\n", name.data());
		}
		Close();
		return 3;
	}
   //c_func=(unsigned int) *((unsigned int *) CleanUp);
   
	GetNumMsgHandlers = (GetNumMsgHandlers_t) dlsym(mod_handle, "GetNumMsgHandlers");
	if((errmsg=dlerror())!=NULL){
		if(DebugMode > 2){
			printf("Can't find GetNumMsgHandlers in module %s\n", name.data());
		}
		Close();
		return 4;
	}
   //g_func=(unsigned int) *((unsigned int *) GetNumMsgHandlers);
   
   GetMsgHandler = (GetMsgHandler_t) dlsym(mod_handle, "GetMsgHandler");
	if((errmsg=dlerror())!=NULL){
		if(DebugMode > 2){
			printf("Can't find GetNumMsgHandlers in module %s\n", name.data());
		}
		Close();
		return 5;
	}
   //j_func=(unsigned int) *((unsigned int *) GetMsgHandler);
   
	Lock = (Lock_t) dlsym(mod_handle, "Lock");
	if((errmsg=dlerror())!=NULL){
		if(DebugMode > 2){
			printf("Can't find Lock in module %s\n", name.data());
		}
		Close();
		return 6;
	}

	Release = (Release_t) dlsym(mod_handle, "Release");
	if((errmsg=dlerror())!=NULL){
		if(DebugMode > 2){
			printf("Can't find Release in module %s\n", name.data());
		}
		Close();
		return 7;
	}
   
   Handler = (Handler_t) dlsym(mod_handle, "Handler");
	if((errmsg=dlerror())!=NULL){
		if(DebugMode > 2){
			printf("Can't find Handler in module %s\n", name.data());
		}
		Close();
		return 9;
	}
   //h_func=(unsigned int) *((unsigned int *) Handler);
   
	if((status=Initialize(arg)) < 0){
      return status;
   }

	return GetHandlers();
}

int CMfPlugIn::GetHandlers()
{
	int i=0;
	unsigned int msg_type;
	int num=GetNumMsgHandlers();

	if(num!=0){
		while(num){
			msg_type=GetMsgHandler(i);
         if(DebugMode > 2){
            /*
            bhm v;
            v.imsg=msg_type;
            printf("cmodhandler: get handler: %d-%d:%d:%d:%d\n", num, v.bmsg[0], v.bmsg[1], v.bmsg[2], v.bmsg[3]);*/
         }
			if(msg_type==0){
            return 16;
         }
			MsgTypes.push_back(msg_type);
         i++;
         num--;
		}
	}

	return 0;
}
int CMfPlugIn::Unload()
{
	Close();
	return 0;
}

bool CMfPlugIn::CanHandle(unsigned int m)
{
	std::list<unsigned int>::iterator i, it=find(MsgTypes.begin(), MsgTypes.end(), m);
   
   if(DebugMode > 2){
      /*
      bhm v;
      v.imsg=m;
      printf("cmodhandler: can handle %d:%d:%d:%d\n", v.bmsg[0], v.bmsg[1], v.bmsg[2], v.bmsg[3]);*/
   }
   
   if(it==MsgTypes.end()) return false;
   
   if(DebugMode > 2){
      printf("cmodhandler: non-empty list\n");
   }

	return true;
}

int CMfPlugIn::Process(unsigned int msg_type, int len, void *data, int flags)
{
	std::list<unsigned int>::iterator it=find(MsgTypes.begin(), MsgTypes.end(), msg_type);
   char *errmsg;
   
	if(it==MsgTypes.end()) return -1;

   if(DebugMode > 2){
      printf("cmodhandler: process\n");
   }
   
   //Handler=(Handler_t) h_func;
   if(Handler!=NULL){
      return Handler(msg_type, len, data, flags);
   }
   /*
   mod_handle= (void *) mod_h;
   Handler=(Handler_t) h_func;
   
   Handler = (Handler_t) dlsym(mod_handle, "Handler");
	if((errmsg=dlerror())!=NULL){
      if(DebugMode > 2){
		   printf("Can't find Handler in module: %s : %d\n", errmsg, mod_h);
		}
		Close();
		return 9;
	}
   else{
	   return Handler(msg_type, len, data, flags);
   }
   */
   return -1;
}

}

}
