/*
saleitem.cpp - a point of sale client class
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001-2004 Al Kingsley
*/

#include "config.h"
#include <fcntl.h>

#include "pos.h"
#include "bhnetwork.h"
#include "ctransitems.h"
#include "cmfengine.h"

namespace bhmfengine {

int CMfPosEngine::PayAuth(bhpos::CPayItem& pi)
{
   CurrPayAuth=pi;
   if(pi.GetID()==bhpos::PTYPE_CREDIT){
      status=MF_STATUS_MAGWAIT;
      hw_signal.emit(BHMF_EVENT_HW_WAITINGONSWIPE, NULL);
   }
   else if(pi.GetID()==bhpos::PTYPE_SMARTC){
      status=MF_STATUS_SMARTWAIT;
      hw_signal.emit(BHMF_EVENT_HW_WAITINGONSMART, NULL);
   }
   // check on extern credit
   /*
   BhPosHdr         hdr;
   BhTransPayCredit *pc=(BhTransPayCredit *) hdr.data;
   */
}

int CMfPosEngine::PayItemAdd(bhpos::CPayItem& pi)
{
   CurrPayAuth=pi;
   transstack.AddPayment(current_transaction, pi, true);
   CustomerDisplay(pi);
}

int CMfPosEngine::PayItemEdit(bhpos::CPayItem& pi)
{
   transstack.Update(current_transaction, pi);
}

int CMfPosEngine::PayItemEdit(bhpos::CPayItem& pi, int n)
{
   //transstack.Update(current_transaction, pi);
}

int CMfPosEngine::PayItemRemove(bhpos::CPayItem& pi)
{
   transstack.Remove(current_transaction, pi);
}

int CMfPosEngine::PayItemRemove(bhpos::CPayItem& pi, int n)
{
   //transstack.Remove(current_transaction, pi);
}

int CMfPosEngine::PayItemRemoveAll()
{
   transstack.ClearPayItems(current_transaction);
}

}
