/*
postmsgctl.cc 
Copyright (C) 2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
   BhPos comes with ABSOLUTELY NO WARRANTY.
*/
#include "config.h"
#include <cstdio>
#include <cstring>

#include "cmfengine.h"

namespace bhmfengine {


/***************************************************************
 *
 * Control Messages
 *
 ***************************************************************/

/*
void servdown_ok()
{
	BhPosHdr	hdr;
	
	memset(&hdr, 0, sizeof(hdr));
	
	hdr.hdr.type=BHPOS_TYPE_SYSTEM;
	hdr.hdr.cmd=BHMSG_SYSTEM_SHUTDOWN;
	hdr.hdr.subcmd=BHMSG_SYSTEM_SHUTDOWN_SHUTDOWN;
	hdr.hdr.size=0;

   trans->SetStatus(TRANSSTATE_QUITACK);
      	
   post->SetStatus(MF_STATUS_ACK);
	post->Post(&hdr, true);
}
*/
void CMfPosEngine::NetworkCtrlMessage(int size, void *data)
{     
   BhMcPosMsg *hdr = (BhMcPosMsg *) data;
#ifdef _DEBUGGERY	
	g_print("ctrl message activity\n");
#endif

	if(hdr->site!=MSG_ALL_SITES){
		if(hdr->dept==connection_info.SiteID){
			if(hdr->dept!=MSG_ALL_DEPTS){
				if(hdr->dept==connection_info.DeparmentID){
					if(hdr->group!=MSG_ALL_GROUPS){
						if(hdr->group==connection_info.GroupID){
							 if(hdr->post!=MSG_ALL_POSTS){
							 	if(hdr->post==connection_info.PostID){
					 				ProcessCtrl(hdr);
							 	}
							 	else{	// not us
							 		return;
							 	}						 	
							 }
							 else{	//dept/group/ all posts
							 	ProcessCtrl(hdr);
							 }
						}
						else{	// not us...
							return;
						}
					}
					else{	// dept/ all groups
						ProcessCtrl(hdr);
					}
				}
				else{	// not us
					return;
				}
			}
			else{	// site / all depts
				ProcessCtrl(hdr);
			}
		}
		else{	// all sites/depts/groups/posts
			ProcessCtrl(hdr);
		}
	}
}
	
int CMfPosEngine::ProcessCtrl(BhMcPosMsg *hdr)
{
#ifdef _DEBUGGERY	
	g_print("ctrl process message: type - %d\n", hdr->hdr.type);
#endif
	switch(hdr->hdr.type){
	case BHMSG_MC_SYSTEM: return CtrlSystem(hdr);
	case BHMSG_MC_CLIENT: return CtrlClient(hdr);
	case BHMSG_MC_MSG: return CtrlMessage(hdr);
   case BHMSG_MC_MENU: return CtrlMenu(hdr);
	}
	return 0;
}

int CMfPosEngine::CtrlSystem(BhMcPosMsg *hdr)
{
	BhPosHdr msg;
	
	switch(hdr->hdr.cmd){
	case BHMSG_MC_SYS_KEEPALIVE:
		// simply send back a null message
		msg.hdr.type=BHPOS_TYPE_POST;
   	msg.hdr.cmd=BHMSG_POST_STATE;
      msg.hdr.subcmd=BHMSG_POST_STATE_KA;
      msg.hdr.Ex=0;
      msg.hdr.size=0;
		Post(&msg, false);
		break;
	case BHMSG_MC_SYS_STATUS:
	case BHMSG_MC_SYS_STANDBY:
	case BHMSG_MC_SYS_SHUTDOWN:
//	   trans->SetStatusBar(3, _("System: Shutting Down"));
	   if(status!=MF_STATUS_IDLE){
//		   PostTransFlagType|=POST_PTFLAGS_SERVSHUTDOWN;
		}
		else{
/*
			csd=manage(new confirm(BHCONFIRMBOX_OK, bModal, _("Server Down"),				
				"/usr/share/bhpos/pixmaps/icon_stop.xpm",
				_("Server is going down, application quitting"),
				&servdown_ok,
				NULL));*/
	   }
		break;
	}
	return 0;
}

int CMfPosEngine::CtrlClient(BhMcPosMsg *hdr)
{
	switch(hdr->hdr.cmd){
	case BHMSG_MC_CLIENT_GET:
		switch(hdr->hdr.subcmd){
		case BHMSG_MC_CLIENT_GET_STATUS:
		case BHMSG_MC_CLIENT_GET_CASH:
		case BHMSG_MC_CLIENT_GET_UPS:
			break;
		}
		break;
	case BHMSG_MC_CLIENT_SET:
		switch(hdr->hdr.subcmd){
		case BHMSG_MC_CLIENT_SET_STATUS:
		case BHMSG_MC_CLIENT_SET_CASH:
		case BHMSG_MC_CLIENT_SET_EXRATE:
		case BHMSG_MC_CLIENT_SET_PRINTERMSG:
		case BHMSG_MC_CLIENT_SET_PRINTERBM:
		case BHMSG_MC_CLIENT_SET_PLUITEM:
		case BHMSG_MC_CLIENT_SET_PLUFLUSH:
			break;
		
		case BHMSG_MC_CLIENT_SET_KEYMAP:
			if(status!=MF_STATUS_IDLE){
//	   	PostTransFlagType|=POST_PTFLAGS_KEYMAP;
			}
			break;
		case BHMSG_MC_CLIENT_SET_KEYMAPDROP:
			if(status!=MF_STATUS_IDLE){
		   	//PostTransFlagType|=POST_PTFLAGS_KEYMAPDROP;
		   }
		   break;
		case BHMSG_MC_CLIENT_SET_KEYMAPADD:
		case BHMSG_MC_CLIENT_SET_KEYMAPEDIT:
		case BHMSG_MC_CLIENT_SET_KEYMAPDELETE:
		   break;
		}
		break;
	}
	return 0;
}

int CMfPosEngine::CtrlMessage(BhMcPosMsg *hdr)
{
   return 0;
}

int CMfPosEngine::CtrlMenu(BhMcPosMsg *hdr)
{
   switch(hdr->hdr.cmd){
   case BHMSG_MC_MENU_CHANGE:
   case BHMSG_MC_MENU_ITEMSTATUSCHANGE:
      break;
   }
   return 0;
}

}
