/*
postmsgsys.cc 
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
   BhPos comes with ABSOLUTELY NO WARRANTY.
*/
#include "config.h"
#include <cstdio>
#include <cstring>

#include "cmfengine.h"

namespace bhmfengine {

/***************************************************************
 * System Messages
 *
 *
 ***************************************************************/

int CMfPosEngine::SystemMessage(BhPosHdr *hdr)
{
	switch(hdr->hdr.cmd){
	case BHMSG_SYSTEM_CONNECTION: return SystemConnect(hdr);
	case BHMSG_SYSTEM_VERSION: return SystemVersion(hdr);
	case BHMSG_SYSTEM_AUTHENTICATE: return SystemAuthenticate(hdr);
	case BHMSG_SYSTEM_SHUTDOWN: return SystemShutdown(hdr);
	case BHMSG_SYSTEM_LOGIN: return SystemLogin(hdr);
	case BHMSG_SYSTEM_INTERFACE: return SystemInterface(hdr);
	case BHMSG_SYSTEM_SERVICE: return SystemService(hdr);
	case BHMSG_SYSTEM_MESSAGE: return SystemMsg(hdr);
      /*
	case BHMSG_SYSTEM_QUERY:	return SystemQuery(hdr);
	case BHMSG_SYSTEM_TIME:	return SystemTime(hdr);
	case BHMSG_SYSTEM_STATISTICS: return SystemStatistics(hdr);
	case BHMSG_SYSTEM_MAP:
	case BHMSG_SYSTEM_USER:
	case BHMSG_SYSTEM_MULTIMASTER:
	case BHMSG_SYSTEM_UPS:
	case BHMSG_SYSTEM_RAID:*/
	case BHMSG_SYSTEM_DEBUG:
		break;
	}
	return 0;
}

int CMfPosEngine::SystemConnect(BhPosHdr *hdr)
{
	BhPosConnectReply *cr;
	BhPosMonetaryUnit *mu;
	int					 temp=0, x, y;
   bool               bm, bt, bp;
   static bool        bn=false;
	
   config.GetOption(MFENG_CONFIG_MODAL, &bm);
   config.GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
   config.GetOption(MFENG_CONFIG_PRN_GLOBAL, &bp);
   
	switch(hdr->hdr.subcmd){
	case BHMSG_SYSTEM_RECONNECT:
	   //g_print("sys reconnect msg");
	   /* Recovery from some error, this message prepares the client
	   for a reload of something, to restore it to the original state
	   before it request the shutdown */
		break;
		
	case BHMSG_SYSTEM_HELLSTEETH:
	   /*
   	   Server went down without warning, and is not backed up - scrap everything
	      no information has been stored... This is a dire message.
	   */
	   //trans->Clear();
	   // connect... sans gouter
	   
	   break;
		
	case BHMSG_SYSTEM_CONNECT:
      //if(bn) return 1;
      //bn=true;
		//if(status >= MF_STATUS_PRNSETUP){
		//   return 1;
		//}
		if(hdr->hdr.Ex==BHPOS_GRANT){
			cr=(BhPosConnectReply *) hdr->data;
			mu=(BhPosMonetaryUnit *) cr->unit;
			temp=(hdr->hdr.size - (sizeof(BhPosConnectReply)-sizeof(BhPosMonetaryUnit)))/sizeof(BhPosMonetaryUnit);
			memcpy(&connection_info, hdr->data, sizeof(connection_info));
		   while(temp){
#ifdef _DEBUGGERY
			   g_print("connect cash %d: %d - %0.2f - %d\n", temp, mu->unit, mu->value, mu->amount);
#endif
  				cashdrawer.Add(mu->unit, mu->value, mu->amount);
   			mu++;
	   		temp--;
		  	}
         system_signal.emit(BHMF_EVENT_CONNECT, NULL);
		}
		else{	// connection refused...
         systemerror_signal.emit(BHMF_EVENT_CONNECT, NULL);
			return 1;
		}
		break;

	case BHMSG_SYSTEM_DISCONNECT:
      system_signal.emit(BHMF_EVENT_DISCONNECT, NULL);
		status=MF_STATUS_UNCONNECTED;
		break;
	}
	return 0;
}

int CMfPosEngine::SystemVersion(BhPosHdr *hdr)
{
	switch(hdr->hdr.subcmd){
	case BHMSG_SYSTEM_VERSION_SERVER:
	case BHMSG_SYSTEM_VERSION_CLIENT:
	case BHMSG_SYSTEM_VERSION_PROTOCOL:
		break;
	}
	return 0;
}

int CMfPosEngine::SystemAuthenticate(BhPosHdr *hdr)
{
	switch(hdr->hdr.subcmd){
	case BHMSG_SYSTEM_AUTHORIZE_1:
	case BHMSG_SYSTEM_AUTHORIZE_2:
	case BHMSG_SYSTEM_AUTHORIZE_3:
		break;
	}
	return 0;
}

int CMfPosEngine::SystemShutdown(BhPosHdr *hdr)
{
	switch(hdr->hdr.subcmd){
	case BHMSG_SYSTEM_SHUTDOWN_SHUTDOWN:
		if(hdr->hdr.Ex==BHPOS_GRANT){
         system_signal.emit(BHMF_EVENT_SHUTDOWN, NULL);
		}
		else{
   	   systemerror_signal.emit(BHMF_EVENT_SHUTDOWN, NULL);
		}
		break;
      
	case BHMSG_SYSTEM_SHUTDOWN_REBOOT:
#ifdef _DEBUGGERY	
		g_print("system reboot");
#endif		
		if(hdr->hdr.Ex==BHPOS_GRANT){
         system_signal.emit(BHMF_EVENT_REBOOT, NULL);
	   }
	   else{
         systemerror_signal.emit(BHMF_EVENT_REBOOT, NULL);
		}
		break;
      
	case BHMSG_SYSTEM_SHUTDOWN_RESTART:
#ifdef _DEBUGGERY	
		g_print("system restart");
#endif
		if(hdr->hdr.Ex==BHPOS_GRANT){
         system_signal.emit(BHMF_EVENT_RESTART, NULL);
	   }
	   else{
         systemerror_signal.emit(BHMF_EVENT_RESTART, NULL);
		}
		break;
	case BHMSG_SYSTEM_SHUTDOWN_SLEEP:
#ifdef _DEBUGGERY	
		g_print("system sleep");
#endif		
		if(hdr->hdr.Ex==BHPOS_GRANT){
         system_signal.emit(BHMF_EVENT_SLEEP, NULL);
	   }
	   else{
         systemerror_signal.emit(BHMF_EVENT_SLEEP, NULL);
		}
		break;
	}
	
	return 0;
}

int CMfPosEngine::SystemService(BhPosHdr *hdr)
{
	switch(hdr->hdr.subcmd){
	case BHMSG_SYSTEM_SERVICE_MONEYUNIT:
	{
		BhPosMoneyReply	*mur;
		BhPosMonetaryUnit *mu;
		
		mur=(BhPosMoneyReply *) hdr->data;
		mu=mur->unit;
	}
		break;
	}

	return 0;
}

int CMfPosEngine::SystemLogin(BhPosHdr *hdr)
{
   bool bm, bt;
	
   config.GetOption(MFENG_CONFIG_MODAL, &bm);
   config.GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
   
	switch(hdr->hdr.subcmd){
	case BHMSG_SYSTEM_LOGIN_BARCODE:
	case BHMSG_SYSTEM_LOGIN_LIPASSIVE:
      if(status==MF_STATUS_USERLOOKUP){
   	//if(status==MF_STATUS_PASSIVELOGOUT){
		   BhLogonReply lr;
			memcpy(&lr, hdr->data, sizeof(lr));
			userID=lr.userID;
			if(hdr->hdr.Ex==BHPOS_REFUSE){
            poserror_signal.emit(BHMF_EVENT_LOGIN, NULL);
            if(bt){
               status=MF_STATUS_PASSIVELOGOUT;
            }
            else{
               status=MF_STATUS_LOGGEDOUT;
            }
				return 0;
			}
         status=MF_STATUS_IDLE;
         Print(bhpos::PRNCMD_CDISPPRESALE, NULL, 0);
         pos_signal.emit(BHMF_EVENT_LOGIN, &lr);
      }    
      break;	

   case BHMSG_SYSTEM_LOGIN_LOGINEXT:
	case BHMSG_SYSTEM_LOGIN_LOGIN:
   {
		if(hdr->hdr.Ex==BHPOS_REFUSE){
			if(bt){
            status=MF_STATUS_PASSIVELOGOUT;
         }
         else{
            status=MF_STATUS_LOGGEDOUT;
         }
         poserror_signal.emit(BHMF_EVENT_LOGIN, NULL);
			return 0;
		}
      BhLogonReply lr;
		memcpy(&lr, hdr->data, sizeof(lr));
      status=MF_STATUS_IDLE;
      userID=lr.userID;
      Print(bhpos::PRNCMD_CDISPPRESALE, NULL, 0);
      pos_signal.emit(BHMF_EVENT_LOGIN, &lr);
   }
		break;

	case BHMSG_SYSTEM_LOGIN_LOGOUT:
		// system granted logout
		if(hdr->hdr.Ex==BHPOS_REFUSE){
			poserror_signal.emit(BHMF_EVENT_LOGOUT, NULL);
		}
		else{
			pos_signal.emit(BHMF_EVENT_LOGOUT, NULL);
         status=MF_STATUS_LOGGEDOUT;
         userID=0;
         Print(bhpos::PRNCMD_CDISPIDLE, NULL, 0);
		}
		break;
      
	case BHMSG_SYSTEM_LOGIN_LOGSUPER:
	case BHMSG_SYSTEM_LOGIN_USERCHANGE:
		break;
	}
	return 0;
}

int CMfPosEngine::SystemInterface(BhPosHdr *hdr)
{
   /*
	BhLogonReply lr;
   bool         bm, bt;
	
   config.GetOption(MFENG_CONFIG_MODAL, &bm);
   config.GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
	
	memcpy(&lr, hdr->data, sizeof(lr));

	if(hdr->hdr.Ex==BHPOS_REFUSE){
		manage(new class confirm(BHCONFIRMBOX_OK, bm, _("Login Error"),
			"/usr/share/bhpos/pixmaps/icon_lierror.xpm",
			_("User Name or Password incorrect"),
			NULL,
			NULL));
		return 0;
	}
	switch(lr.interfaceID){
	case BHIF_TRANSACTION:
		if(interfaceID!=lr.interfaceID){
			trans->SetMode(TRANS_MODE_TRANSACTION);
			userID=lr.userID;
			interfaceID=lr.interfaceID;
			strcpy(userName_A, lr.userdispname);
			status=MF_STATUS_LOGGEDIN;
			mode=POST_MODE_IDLE;
			strcat(u, userName_A);			
			trans->SetStatusBar(0, "Status : Idle");
			trans->SetStatusBar(1, u);
			//trans->SetStatusBar(1, u);
			trans->SetStatusBar(2, "Ready");
			trans->SetStatusBar(3, "System : Connected");
		}
		break;
			
	case BHIF_CASHDRAWER:
      trans->SetMode(TRANS_MODE_CASHADJUST);
      break;

	case BHIF_RETURNS:
      if(status==MF_STATUS_IDLE){
	      if(bAllowPassiveReturns) trans->SetMode(TRANS_MODE_RETURNSPASS); 
	      else trans->SetMode(TRANS_MODE_RETURNS);
	   }
		break;
      
	case BHIF_PAYIN:
	   trans->FireDrawer(0, false);
      pio=manage(new pay(false, bModal, payout_ok, NULL));
      break;
   
	case BHIF_PAYOUT:
	   trans->FireDrawer(0, false);
      pio=manage(new pay(true, bModal, payin_ok, NULL));
      break;
   
	case BHIF_TRANSUMMARY:
	case BHIF_USERSUMMARY:
	case BHIF_XTAPE:
	case BHIF_ZTAPE:
	case BHIF_DISCOUNT:
		break;
	}

   t_userID=lr.userID;
	t_interfaceID=lr.interfaceID;
	strcpy(t_userName, lr.userdispname);
   trans->SetStatusBar(0, "Status : Idle");
   trans->SetStatusBar(1, t_userName);
   trans->SetStatusBar(2, "Ready");
   trans->SetStatusBar(3, "System : Connected");
   trans->Interface();
*/
/*
	switch(hdr->hdr.subcmd){
	case BHMSG_SYSTEM_INTERFACE_LOGIN:
		break;
	case BHMSG_SYSTEM_INTERFACE_BARCODE:
		break;
	case BHMSG_SYSTEM_INTERFACE_MAGSWIPE:
		break;
	case BHMSG_SYSTEM_INTERFACE_SMARTCARD:
		if(hdr->hdr.Ex==BHPOS_REFUSE){
			
		}
		break;
	}*/
	return 0;
}

int CMfPosEngine::SystemMsg(BhPosHdr *hdr)
{
	return 0;
}

int CMfPosEngine::SystemQuery(BhPosHdr *hdr)
{
	return 0;
}

int CMfPosEngine::SystemTime(BhPosHdr *hdr)
{
	return 0;
}
int CMfPosEngine::SystemStatistics(BhPosHdr *hdr)
{
	return 0;
}

void CMfPosEngine::NetworkTimeout()
{
   /*
   switch(status){
   case MF_STATUS_ACK:
      switch(trans->GetStatus()){
      case TRANSSTATE_QUITACK:
         if(bLogoutEveryTrans){
		      if(Close()) Gtk::Main::quit();
		   }
		   else{
   			li->destroy();
			   if(Close()) Gtk::Main::quit();
			}
		}
   }
   */
}

}
